// SPDX-License-Identifier: GPL-2.1-or-later
/*
 * gp_convert.gen.h
 *
 * GENERATED on 2023 10 30 20:24:52 from gp_convert.gen.h.t
 *
 * DO NOT MODIFY THIS FILE DIRECTLY!
 */
#ifndef GP_CONVERT_GEN_H
#define GP_CONVERT_GEN_H

/*
 * Convert PixelType values macros and functions
 *
 * Copyright (C) 2011-2014 Cyril Hrubis <metan@ucw.cz>
 * Copyright (C) 2011      Tomas Gavenciak <gavento@ucw.cz>
 */

#include <core/gp_get_set_bits.h>
#include "core/gp_pixmap.h"
#include <core/gp_pixel.h>

/*** RGB888 -> xRGB8888 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (xRGB8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_xRGB8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_xRGB8888(p1, p2) \
        GP_PIXEL_RGB888_TO_xRGB8888_OFFSET(p1, 0, p2, 0)

/*** xRGB8888 -> RGB888 ***
 * macro reads p1 (xRGB8888 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_xRGB8888_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_xRGB8888_TO_RGB888(p1, p2) \
        GP_PIXEL_xRGB8888_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> RGBA8888 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_RGBA8888(p1, p2) \
        GP_PIXEL_RGB888_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> RGB888 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_RGB888(p1, p2) \
        GP_PIXEL_RGB888_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> BGR888 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (BGR888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_BGR888_OFFSET(p1, o1, p2, o2) do { \
        /* B:=B */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* R:=R */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_BGR888(p1, p2) \
        GP_PIXEL_RGB888_TO_BGR888_OFFSET(p1, 0, p2, 0)

/*** BGR888 -> RGB888 ***
 * macro reads p1 (BGR888 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_BGR888_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_BGR888_TO_RGB888(p1, p2) \
        GP_PIXEL_BGR888_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> RGB555 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (RGB555 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_RGB555_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(10+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(5+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_RGB555(p1, p2) \
        GP_PIXEL_RGB888_TO_RGB555_OFFSET(p1, 0, p2, 0)

/*** RGB555 -> RGB888 ***
 * macro reads p1 (RGB555 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB555_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(10+o1, 5, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(5+o1, 5, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(0+o1, 5, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB555_TO_RGB888(p1, p2) \
        GP_PIXEL_RGB555_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> RGB565 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (RGB565 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_RGB565_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(11+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(5+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_RGB565(p1, p2) \
        GP_PIXEL_RGB888_TO_RGB565_OFFSET(p1, 0, p2, 0)

/*** RGB565 -> RGB888 ***
 * macro reads p1 (RGB565 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB565_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(11+o1, 5, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(5+o1, 6, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(0+o1, 5, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB565_TO_RGB888(p1, p2) \
        GP_PIXEL_RGB565_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> RGB666 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (RGB666 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_RGB666_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(12+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(6+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_RGB666(p1, p2) \
        GP_PIXEL_RGB888_TO_RGB666_OFFSET(p1, 0, p2, 0)

/*** RGB666 -> RGB888 ***
 * macro reads p1 (RGB666 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB666_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(12+o1, 6, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(6+o1, 6, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(0+o1, 6, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB666_TO_RGB888(p1, p2) \
        GP_PIXEL_RGB666_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> RGB332 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (RGB332 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_RGB332_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(5+o2, 3, p2,\
                GP_SCALE_VAL_8_3(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(2+o2, 3, p2,\
                GP_SCALE_VAL_8_3(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 2, p2,\
                GP_SCALE_VAL_8_2(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_RGB332(p1, p2) \
        GP_PIXEL_RGB888_TO_RGB332_OFFSET(p1, 0, p2, 0)

/*** RGB332 -> RGB888 ***
 * macro reads p1 (RGB332 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB332_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_3_8(GP_GET_BITS(5+o1, 3, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_3_8(GP_GET_BITS(2+o1, 3, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB332_TO_RGB888(p1, p2) \
        GP_PIXEL_RGB332_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> CMYK8888 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (CMYK8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_CMYK8888_OFFSET(p1, o1, p2, o2) do { \
	gp_pixel gp_r = GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1)); \
	gp_pixel gp_g = GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1)); \
	gp_pixel gp_b = GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1)); \
	gp_pixel gp_k = GP_MAX3(gp_r, gp_g, gp_b); \
	GP_SET_BITS(0+o2, 8, p2, GP_SCALE_VAL_8_8((gp_k - gp_r))); \
	GP_SET_BITS(8+o2, 8, p2, GP_SCALE_VAL_8_8((gp_k - gp_g))); \
	GP_SET_BITS(16+o2, 8, p2, GP_SCALE_VAL_8_8((gp_k - gp_b))); \
	GP_SET_BITS(24+o2, 8, p2, GP_SCALE_VAL_8_8(255 - gp_k)); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_CMYK8888(p1, p2) \
        GP_PIXEL_RGB888_TO_CMYK8888_OFFSET(p1, 0, p2, 0)

/*** CMYK8888 -> RGB888 ***
 * macro reads p1 (CMYK8888 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_CMYK8888_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
	GP_SET_BITS(16+o2, 8, p2,\
                    ((0xff * (0xff - GP_GET_BITS(24+o1, 8, p1)) * \
                     (0xff - GP_GET_BITS(0+o1, 8, p1)))) / (0xff * 0xff) \
		    ); \
	GP_SET_BITS(8+o2, 8, p2,\
                    ((0xff * (0xff - GP_GET_BITS(24+o1, 8, p1)) * \
                     (0xff - GP_GET_BITS(8+o1, 8, p1)))) / (0xff * 0xff) \
		    ); \
	GP_SET_BITS(0+o2, 8, p2,\
                    ((0xff * (0xff - GP_GET_BITS(24+o1, 8, p1)) * \
                     (0xff - GP_GET_BITS(16+o1, 8, p1)))) / (0xff * 0xff) \
		    ); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_CMYK8888_TO_RGB888(p1, p2) \
        GP_PIXEL_CMYK8888_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> G1_DB ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (G1_DB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_G1_DB_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 1, p2, ( \
                /* R */ GP_SCALE_VAL_8_1(GP_GET_BITS(16+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_1(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_1(GP_GET_BITS(0+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_G1_DB(p1, p2) \
        GP_PIXEL_RGB888_TO_G1_DB_OFFSET(p1, 0, p2, 0)

/*** G1_DB -> RGB888 ***
 * macro reads p1 (G1_DB at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G1_DB_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G1_DB_TO_RGB888(p1, p2) \
        GP_PIXEL_G1_DB_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> G2_DB ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (G2_DB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_G2_DB_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 2, p2, ( \
                /* R */ GP_SCALE_VAL_8_2(GP_GET_BITS(16+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_2(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_2(GP_GET_BITS(0+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_G2_DB(p1, p2) \
        GP_PIXEL_RGB888_TO_G2_DB_OFFSET(p1, 0, p2, 0)

/*** G2_DB -> RGB888 ***
 * macro reads p1 (G2_DB at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G2_DB_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G2_DB_TO_RGB888(p1, p2) \
        GP_PIXEL_G2_DB_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> G4_DB ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (G4_DB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_G4_DB_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 4, p2, ( \
                /* R */ GP_SCALE_VAL_8_4(GP_GET_BITS(16+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_4(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_4(GP_GET_BITS(0+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_G4_DB(p1, p2) \
        GP_PIXEL_RGB888_TO_G4_DB_OFFSET(p1, 0, p2, 0)

/*** G4_DB -> RGB888 ***
 * macro reads p1 (G4_DB at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G4_DB_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G4_DB_TO_RGB888(p1, p2) \
        GP_PIXEL_G4_DB_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> G1_UB ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (G1_UB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_G1_UB_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 1, p2, ( \
                /* R */ GP_SCALE_VAL_8_1(GP_GET_BITS(16+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_1(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_1(GP_GET_BITS(0+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_G1_UB(p1, p2) \
        GP_PIXEL_RGB888_TO_G1_UB_OFFSET(p1, 0, p2, 0)

/*** G1_UB -> RGB888 ***
 * macro reads p1 (G1_UB at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G1_UB_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G1_UB_TO_RGB888(p1, p2) \
        GP_PIXEL_G1_UB_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> G2_UB ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (G2_UB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_G2_UB_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 2, p2, ( \
                /* R */ GP_SCALE_VAL_8_2(GP_GET_BITS(16+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_2(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_2(GP_GET_BITS(0+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_G2_UB(p1, p2) \
        GP_PIXEL_RGB888_TO_G2_UB_OFFSET(p1, 0, p2, 0)

/*** G2_UB -> RGB888 ***
 * macro reads p1 (G2_UB at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G2_UB_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G2_UB_TO_RGB888(p1, p2) \
        GP_PIXEL_G2_UB_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> G4_UB ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (G4_UB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_G4_UB_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 4, p2, ( \
                /* R */ GP_SCALE_VAL_8_4(GP_GET_BITS(16+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_4(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_4(GP_GET_BITS(0+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_G4_UB(p1, p2) \
        GP_PIXEL_RGB888_TO_G4_UB_OFFSET(p1, 0, p2, 0)

/*** G4_UB -> RGB888 ***
 * macro reads p1 (G4_UB at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G4_UB_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G4_UB_TO_RGB888(p1, p2) \
        GP_PIXEL_G4_UB_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> G8 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_G8_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 8, p2, ( \
                /* R */ GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_G8(p1, p2) \
        GP_PIXEL_RGB888_TO_G8_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> GA88 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (GA88 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_GA88_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 8, p2, ( \
                /* R */ GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1)) + \
        0)/3);\
        /* A:=0xff */GP_SET_BITS(8+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_GA88(p1, p2) \
        GP_PIXEL_RGB888_TO_GA88_OFFSET(p1, 0, p2, 0)

/*** GA88 -> RGB888 ***
 * macro reads p1 (GA88 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_GA88_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_GA88_TO_RGB888(p1, p2) \
        GP_PIXEL_GA88_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGB888 -> G16 ***
 * macro reads p1 (RGB888 at bit-offset o1)
 * and writes to p2 (G16 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB888_TO_G16_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 16, p2, ( \
                /* R */ GP_SCALE_VAL_8_16(GP_GET_BITS(16+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_16(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_16(GP_GET_BITS(0+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB888_TO_G16(p1, p2) \
        GP_PIXEL_RGB888_TO_G16_OFFSET(p1, 0, p2, 0)

/*** G16 -> RGB888 ***
 * macro reads p1 (G16 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G16_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_16_8(GP_GET_BITS(0+o1, 16, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_16_8(GP_GET_BITS(0+o1, 16, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_16_8(GP_GET_BITS(0+o1, 16, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G16_TO_RGB888(p1, p2) \
        GP_PIXEL_G16_TO_RGB888_OFFSET(p1, 0, p2, 0)


/*
 * Convert RGB888 to any other pixel type
 * Does not work on palette types at all (yet)
 */
gp_pixel gp_RGB888_to_pixel(gp_pixel pixel, gp_pixel_type type);

/*
 * Function converting to RGB888 from any other pixel type
 * Does not work on palette types at all (yet)
 */
gp_pixel gp_pixel_to_RGB888(gp_pixel pixel, gp_pixel_type type);

/*** RGBA8888 -> xRGB8888 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (xRGB8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_xRGB8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(24+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_xRGB8888(p1, p2) \
        GP_PIXEL_RGBA8888_TO_xRGB8888_OFFSET(p1, 0, p2, 0)

/*** xRGB8888 -> RGBA8888 ***
 * macro reads p1 (xRGB8888 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_xRGB8888_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_xRGB8888_TO_RGBA8888(p1, p2) \
        GP_PIXEL_xRGB8888_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> RGBA8888 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(24+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* A:=A */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_RGBA8888(p1, p2) \
        GP_PIXEL_RGBA8888_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> RGB888 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(24+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_RGB888(p1, p2) \
        GP_PIXEL_RGBA8888_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> BGR888 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (BGR888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_BGR888_OFFSET(p1, o1, p2, o2) do { \
        /* B:=B */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* R:=R */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(24+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_BGR888(p1, p2) \
        GP_PIXEL_RGBA8888_TO_BGR888_OFFSET(p1, 0, p2, 0)

/*** BGR888 -> RGBA8888 ***
 * macro reads p1 (BGR888 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_BGR888_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_BGR888_TO_RGBA8888(p1, p2) \
        GP_PIXEL_BGR888_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> RGB555 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (RGB555 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_RGB555_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(10+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(24+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(5+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(16+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(8+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_RGB555(p1, p2) \
        GP_PIXEL_RGBA8888_TO_RGB555_OFFSET(p1, 0, p2, 0)

/*** RGB555 -> RGBA8888 ***
 * macro reads p1 (RGB555 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB555_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(10+o1, 5, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(5+o1, 5, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(0+o1, 5, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB555_TO_RGBA8888(p1, p2) \
        GP_PIXEL_RGB555_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> RGB565 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (RGB565 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_RGB565_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(11+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(24+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(5+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(16+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(8+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_RGB565(p1, p2) \
        GP_PIXEL_RGBA8888_TO_RGB565_OFFSET(p1, 0, p2, 0)

/*** RGB565 -> RGBA8888 ***
 * macro reads p1 (RGB565 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB565_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(11+o1, 5, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(5+o1, 6, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(0+o1, 5, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB565_TO_RGBA8888(p1, p2) \
        GP_PIXEL_RGB565_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> RGB666 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (RGB666 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_RGB666_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(12+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(24+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(6+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(16+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(8+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_RGB666(p1, p2) \
        GP_PIXEL_RGBA8888_TO_RGB666_OFFSET(p1, 0, p2, 0)

/*** RGB666 -> RGBA8888 ***
 * macro reads p1 (RGB666 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB666_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(12+o1, 6, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(6+o1, 6, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(0+o1, 6, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB666_TO_RGBA8888(p1, p2) \
        GP_PIXEL_RGB666_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> RGB332 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (RGB332 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_RGB332_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(5+o2, 3, p2,\
                GP_SCALE_VAL_8_3(GP_GET_BITS(24+o1, 8, p1))); \
        /* G:=G */ GP_SET_BITS(2+o2, 3, p2,\
                GP_SCALE_VAL_8_3(GP_GET_BITS(16+o1, 8, p1))); \
        /* B:=B */ GP_SET_BITS(0+o2, 2, p2,\
                GP_SCALE_VAL_8_2(GP_GET_BITS(8+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_RGB332(p1, p2) \
        GP_PIXEL_RGBA8888_TO_RGB332_OFFSET(p1, 0, p2, 0)

/*** RGB332 -> RGBA8888 ***
 * macro reads p1 (RGB332 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB332_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_3_8(GP_GET_BITS(5+o1, 3, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_3_8(GP_GET_BITS(2+o1, 3, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB332_TO_RGBA8888(p1, p2) \
        GP_PIXEL_RGB332_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> CMYK8888 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (CMYK8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_CMYK8888_OFFSET(p1, o1, p2, o2) do { \
	gp_pixel gp_r = GP_SCALE_VAL_8_8(GP_GET_BITS(24+o1, 8, p1)); \
	gp_pixel gp_g = GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1)); \
	gp_pixel gp_b = GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1)); \
	gp_pixel gp_k = GP_MAX3(gp_r, gp_g, gp_b); \
	GP_SET_BITS(0+o2, 8, p2, GP_SCALE_VAL_8_8((gp_k - gp_r))); \
	GP_SET_BITS(8+o2, 8, p2, GP_SCALE_VAL_8_8((gp_k - gp_g))); \
	GP_SET_BITS(16+o2, 8, p2, GP_SCALE_VAL_8_8((gp_k - gp_b))); \
	GP_SET_BITS(24+o2, 8, p2, GP_SCALE_VAL_8_8(255 - gp_k)); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_CMYK8888(p1, p2) \
        GP_PIXEL_RGBA8888_TO_CMYK8888_OFFSET(p1, 0, p2, 0)

/*** CMYK8888 -> RGBA8888 ***
 * macro reads p1 (CMYK8888 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_CMYK8888_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
	GP_SET_BITS(24+o2, 8, p2,\
                    ((0xff * (0xff - GP_GET_BITS(24+o1, 8, p1)) * \
                     (0xff - GP_GET_BITS(0+o1, 8, p1)))) / (0xff * 0xff) \
		    ); \
	GP_SET_BITS(16+o2, 8, p2,\
                    ((0xff * (0xff - GP_GET_BITS(24+o1, 8, p1)) * \
                     (0xff - GP_GET_BITS(8+o1, 8, p1)))) / (0xff * 0xff) \
		    ); \
	GP_SET_BITS(8+o2, 8, p2,\
                    ((0xff * (0xff - GP_GET_BITS(24+o1, 8, p1)) * \
                     (0xff - GP_GET_BITS(16+o1, 8, p1)))) / (0xff * 0xff) \
		    ); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_CMYK8888_TO_RGBA8888(p1, p2) \
        GP_PIXEL_CMYK8888_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> G1_DB ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (G1_DB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_G1_DB_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 1, p2, ( \
                /* R */ GP_SCALE_VAL_8_1(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_1(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_1(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_G1_DB(p1, p2) \
        GP_PIXEL_RGBA8888_TO_G1_DB_OFFSET(p1, 0, p2, 0)

/*** G1_DB -> RGBA8888 ***
 * macro reads p1 (G1_DB at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G1_DB_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
        /* G:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
        /* B:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G1_DB_TO_RGBA8888(p1, p2) \
        GP_PIXEL_G1_DB_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> G2_DB ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (G2_DB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_G2_DB_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 2, p2, ( \
                /* R */ GP_SCALE_VAL_8_2(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_2(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_2(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_G2_DB(p1, p2) \
        GP_PIXEL_RGBA8888_TO_G2_DB_OFFSET(p1, 0, p2, 0)

/*** G2_DB -> RGBA8888 ***
 * macro reads p1 (G2_DB at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G2_DB_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* G:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* B:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G2_DB_TO_RGBA8888(p1, p2) \
        GP_PIXEL_G2_DB_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> G4_DB ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (G4_DB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_G4_DB_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 4, p2, ( \
                /* R */ GP_SCALE_VAL_8_4(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_4(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_4(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_G4_DB(p1, p2) \
        GP_PIXEL_RGBA8888_TO_G4_DB_OFFSET(p1, 0, p2, 0)

/*** G4_DB -> RGBA8888 ***
 * macro reads p1 (G4_DB at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G4_DB_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
        /* G:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
        /* B:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G4_DB_TO_RGBA8888(p1, p2) \
        GP_PIXEL_G4_DB_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> G1_UB ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (G1_UB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_G1_UB_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 1, p2, ( \
                /* R */ GP_SCALE_VAL_8_1(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_1(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_1(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_G1_UB(p1, p2) \
        GP_PIXEL_RGBA8888_TO_G1_UB_OFFSET(p1, 0, p2, 0)

/*** G1_UB -> RGBA8888 ***
 * macro reads p1 (G1_UB at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G1_UB_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
        /* G:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
        /* B:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G1_UB_TO_RGBA8888(p1, p2) \
        GP_PIXEL_G1_UB_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> G2_UB ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (G2_UB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_G2_UB_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 2, p2, ( \
                /* R */ GP_SCALE_VAL_8_2(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_2(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_2(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_G2_UB(p1, p2) \
        GP_PIXEL_RGBA8888_TO_G2_UB_OFFSET(p1, 0, p2, 0)

/*** G2_UB -> RGBA8888 ***
 * macro reads p1 (G2_UB at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G2_UB_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* G:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* B:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G2_UB_TO_RGBA8888(p1, p2) \
        GP_PIXEL_G2_UB_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> G4_UB ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (G4_UB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_G4_UB_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 4, p2, ( \
                /* R */ GP_SCALE_VAL_8_4(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_4(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_4(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_G4_UB(p1, p2) \
        GP_PIXEL_RGBA8888_TO_G4_UB_OFFSET(p1, 0, p2, 0)

/*** G4_UB -> RGBA8888 ***
 * macro reads p1 (G4_UB at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G4_UB_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
        /* G:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
        /* B:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G4_UB_TO_RGBA8888(p1, p2) \
        GP_PIXEL_G4_UB_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> G8 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_G8_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 8, p2, ( \
                /* R */ GP_SCALE_VAL_8_8(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_G8(p1, p2) \
        GP_PIXEL_RGBA8888_TO_G8_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> GA88 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (GA88 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_GA88_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 8, p2, ( \
                /* R */ GP_SCALE_VAL_8_8(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
        /* A:=A */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_GA88(p1, p2) \
        GP_PIXEL_RGBA8888_TO_GA88_OFFSET(p1, 0, p2, 0)

/*** GA88 -> RGBA8888 ***
 * macro reads p1 (GA88 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_GA88_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* B:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* A:=A */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_GA88_TO_RGBA8888(p1, p2) \
        GP_PIXEL_GA88_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> G16 ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (G16 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_G16_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 16, p2, ( \
                /* R */ GP_SCALE_VAL_8_16(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_16(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_16(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_G16(p1, p2) \
        GP_PIXEL_RGBA8888_TO_G16_OFFSET(p1, 0, p2, 0)

/*** G16 -> RGBA8888 ***
 * macro reads p1 (G16 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G16_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_16_8(GP_GET_BITS(0+o1, 16, p1))); \
        /* G:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_16_8(GP_GET_BITS(0+o1, 16, p1))); \
        /* B:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_16_8(GP_GET_BITS(0+o1, 16, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G16_TO_RGBA8888(p1, p2) \
        GP_PIXEL_G16_TO_RGBA8888_OFFSET(p1, 0, p2, 0)


/*
 * Convert RGBA8888 to any other pixel type
 * Does not work on palette types at all (yet)
 */
gp_pixel gp_RGBA8888_to_pixel(gp_pixel pixel, gp_pixel_type type);

/*
 * Function converting to RGBA8888 from any other pixel type
 * Does not work on palette types at all (yet)
 */
gp_pixel gp_pixel_to_RGBA8888(gp_pixel pixel, gp_pixel_type type);

/*** G8 -> xRGB8888 ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (xRGB8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_xRGB8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_xRGB8888(p1, p2) \
        GP_PIXEL_G8_TO_xRGB8888_OFFSET(p1, 0, p2, 0)

/*** xRGB8888 -> G8 ***
 * macro reads p1 (xRGB8888 at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_xRGB8888_TO_G8_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 8, p2, ( \
                /* R */ GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_xRGB8888_TO_G8(p1, p2) \
        GP_PIXEL_xRGB8888_TO_G8_OFFSET(p1, 0, p2, 0)

/*** G8 -> RGBA8888 ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* B:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_RGBA8888(p1, p2) \
        GP_PIXEL_G8_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** G8 -> RGB888 ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (RGB888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_RGB888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_RGB888(p1, p2) \
        GP_PIXEL_G8_TO_RGB888_OFFSET(p1, 0, p2, 0)

/*** G8 -> BGR888 ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (BGR888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_BGR888_OFFSET(p1, o1, p2, o2) do { \
        /* B:=V */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=V */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* R:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_BGR888(p1, p2) \
        GP_PIXEL_G8_TO_BGR888_OFFSET(p1, 0, p2, 0)

/*** BGR888 -> G8 ***
 * macro reads p1 (BGR888 at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_BGR888_TO_G8_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 8, p2, ( \
                /* R */ GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_8(GP_GET_BITS(8+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_8(GP_GET_BITS(16+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_BGR888_TO_G8(p1, p2) \
        GP_PIXEL_BGR888_TO_G8_OFFSET(p1, 0, p2, 0)

/*** G8 -> RGB555 ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (RGB555 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_RGB555_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(10+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=V */ GP_SET_BITS(5+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(0+o1, 8, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_RGB555(p1, p2) \
        GP_PIXEL_G8_TO_RGB555_OFFSET(p1, 0, p2, 0)

/*** RGB555 -> G8 ***
 * macro reads p1 (RGB555 at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB555_TO_G8_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 8, p2, ( \
                /* R */ GP_SCALE_VAL_5_8(GP_GET_BITS(10+o1, 5, p1)) + \
                /* G */ GP_SCALE_VAL_5_8(GP_GET_BITS(5+o1, 5, p1)) + \
                /* B */ GP_SCALE_VAL_5_8(GP_GET_BITS(0+o1, 5, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB555_TO_G8(p1, p2) \
        GP_PIXEL_RGB555_TO_G8_OFFSET(p1, 0, p2, 0)

/*** G8 -> RGB565 ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (RGB565 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_RGB565_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(11+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=V */ GP_SET_BITS(5+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(0+o1, 8, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 5, p2,\
                GP_SCALE_VAL_8_5(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_RGB565(p1, p2) \
        GP_PIXEL_G8_TO_RGB565_OFFSET(p1, 0, p2, 0)

/*** RGB565 -> G8 ***
 * macro reads p1 (RGB565 at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB565_TO_G8_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 8, p2, ( \
                /* R */ GP_SCALE_VAL_5_8(GP_GET_BITS(11+o1, 5, p1)) + \
                /* G */ GP_SCALE_VAL_6_8(GP_GET_BITS(5+o1, 6, p1)) + \
                /* B */ GP_SCALE_VAL_5_8(GP_GET_BITS(0+o1, 5, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB565_TO_G8(p1, p2) \
        GP_PIXEL_RGB565_TO_G8_OFFSET(p1, 0, p2, 0)

/*** G8 -> RGB666 ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (RGB666 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_RGB666_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(12+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=V */ GP_SET_BITS(6+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(0+o1, 8, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 6, p2,\
                GP_SCALE_VAL_8_6(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_RGB666(p1, p2) \
        GP_PIXEL_G8_TO_RGB666_OFFSET(p1, 0, p2, 0)

/*** RGB666 -> G8 ***
 * macro reads p1 (RGB666 at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB666_TO_G8_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 8, p2, ( \
                /* R */ GP_SCALE_VAL_6_8(GP_GET_BITS(12+o1, 6, p1)) + \
                /* G */ GP_SCALE_VAL_6_8(GP_GET_BITS(6+o1, 6, p1)) + \
                /* B */ GP_SCALE_VAL_6_8(GP_GET_BITS(0+o1, 6, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB666_TO_G8(p1, p2) \
        GP_PIXEL_RGB666_TO_G8_OFFSET(p1, 0, p2, 0)

/*** G8 -> RGB332 ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (RGB332 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_RGB332_OFFSET(p1, o1, p2, o2) do { \
        /* R:=V */ GP_SET_BITS(5+o2, 3, p2,\
                GP_SCALE_VAL_8_3(GP_GET_BITS(0+o1, 8, p1))); \
        /* G:=V */ GP_SET_BITS(2+o2, 3, p2,\
                GP_SCALE_VAL_8_3(GP_GET_BITS(0+o1, 8, p1))); \
        /* B:=V */ GP_SET_BITS(0+o2, 2, p2,\
                GP_SCALE_VAL_8_2(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_RGB332(p1, p2) \
        GP_PIXEL_G8_TO_RGB332_OFFSET(p1, 0, p2, 0)

/*** RGB332 -> G8 ***
 * macro reads p1 (RGB332 at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB332_TO_G8_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 8, p2, ( \
                /* R */ GP_SCALE_VAL_3_8(GP_GET_BITS(5+o1, 3, p1)) + \
                /* G */ GP_SCALE_VAL_3_8(GP_GET_BITS(2+o1, 3, p1)) + \
                /* B */ GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB332_TO_G8(p1, p2) \
        GP_PIXEL_RGB332_TO_G8_OFFSET(p1, 0, p2, 0)

/*** G8 -> CMYK8888 ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (CMYK8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_CMYK8888_OFFSET(p1, o1, p2, o2) do { \
GP_ABORT("Channel conversion G8 to CMYK8888 not supported."); \
GP_ABORT("Channel conversion G8 to CMYK8888 not supported."); \
GP_ABORT("Channel conversion G8 to CMYK8888 not supported."); \
GP_ABORT("Channel conversion G8 to CMYK8888 not supported."); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_CMYK8888(p1, p2) \
        GP_PIXEL_G8_TO_CMYK8888_OFFSET(p1, 0, p2, 0)

/*** CMYK8888 -> G8 ***
 * macro reads p1 (CMYK8888 at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_CMYK8888_TO_G8_OFFSET(p1, o1, p2, o2) do { \
	GP_SET_BITS(0+o2, 8, p2, (\
                    ((0xff * (0xff - GP_GET_BITS(24+o1, 8, p1)) * \
                     (0xff - GP_GET_BITS(0+o1, 8, p1)))) / (0xff * 0xff) \
                    + ((0xff * (0xff - GP_GET_BITS(24+o1, 8, p1)) * \
                    +  (0xff - GP_GET_BITS(8+o1, 8, p1)))) / (0xff * 0xff) \
                    + ((0xff * (0xff - GP_GET_BITS(24+o1, 8, p1)) * \
                    +  (0xff - GP_GET_BITS(16+o1, 8, p1)))) / (0xff * 0xff) \
		    )/3); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_CMYK8888_TO_G8(p1, p2) \
        GP_PIXEL_CMYK8888_TO_G8_OFFSET(p1, 0, p2, 0)

/*** G8 -> G1_DB ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (G1_DB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_G1_DB_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 1, p2,\
                GP_SCALE_VAL_8_1(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_G1_DB(p1, p2) \
        GP_PIXEL_G8_TO_G1_DB_OFFSET(p1, 0, p2, 0)

/*** G1_DB -> G8 ***
 * macro reads p1 (G1_DB at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G1_DB_TO_G8_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G1_DB_TO_G8(p1, p2) \
        GP_PIXEL_G1_DB_TO_G8_OFFSET(p1, 0, p2, 0)

/*** G8 -> G2_DB ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (G2_DB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_G2_DB_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 2, p2,\
                GP_SCALE_VAL_8_2(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_G2_DB(p1, p2) \
        GP_PIXEL_G8_TO_G2_DB_OFFSET(p1, 0, p2, 0)

/*** G2_DB -> G8 ***
 * macro reads p1 (G2_DB at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G2_DB_TO_G8_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G2_DB_TO_G8(p1, p2) \
        GP_PIXEL_G2_DB_TO_G8_OFFSET(p1, 0, p2, 0)

/*** G8 -> G4_DB ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (G4_DB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_G4_DB_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 4, p2,\
                GP_SCALE_VAL_8_4(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_G4_DB(p1, p2) \
        GP_PIXEL_G8_TO_G4_DB_OFFSET(p1, 0, p2, 0)

/*** G4_DB -> G8 ***
 * macro reads p1 (G4_DB at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G4_DB_TO_G8_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G4_DB_TO_G8(p1, p2) \
        GP_PIXEL_G4_DB_TO_G8_OFFSET(p1, 0, p2, 0)

/*** G8 -> G1_UB ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (G1_UB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_G1_UB_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 1, p2,\
                GP_SCALE_VAL_8_1(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_G1_UB(p1, p2) \
        GP_PIXEL_G8_TO_G1_UB_OFFSET(p1, 0, p2, 0)

/*** G1_UB -> G8 ***
 * macro reads p1 (G1_UB at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G1_UB_TO_G8_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_1_8(GP_GET_BITS(0+o1, 1, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G1_UB_TO_G8(p1, p2) \
        GP_PIXEL_G1_UB_TO_G8_OFFSET(p1, 0, p2, 0)

/*** G8 -> G2_UB ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (G2_UB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_G2_UB_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 2, p2,\
                GP_SCALE_VAL_8_2(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_G2_UB(p1, p2) \
        GP_PIXEL_G8_TO_G2_UB_OFFSET(p1, 0, p2, 0)

/*** G2_UB -> G8 ***
 * macro reads p1 (G2_UB at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G2_UB_TO_G8_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_2_8(GP_GET_BITS(0+o1, 2, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G2_UB_TO_G8(p1, p2) \
        GP_PIXEL_G2_UB_TO_G8_OFFSET(p1, 0, p2, 0)

/*** G8 -> G4_UB ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (G4_UB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_G4_UB_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 4, p2,\
                GP_SCALE_VAL_8_4(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_G4_UB(p1, p2) \
        GP_PIXEL_G8_TO_G4_UB_OFFSET(p1, 0, p2, 0)

/*** G4_UB -> G8 ***
 * macro reads p1 (G4_UB at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G4_UB_TO_G8_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_4_8(GP_GET_BITS(0+o1, 4, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G4_UB_TO_G8(p1, p2) \
        GP_PIXEL_G4_UB_TO_G8_OFFSET(p1, 0, p2, 0)

/*** G8 -> G8 ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_G8_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_G8(p1, p2) \
        GP_PIXEL_G8_TO_G8_OFFSET(p1, 0, p2, 0)

/*** G8 -> GA88 ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (GA88 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_GA88_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
        /* A:=0xff */GP_SET_BITS(8+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_GA88(p1, p2) \
        GP_PIXEL_G8_TO_GA88_OFFSET(p1, 0, p2, 0)

/*** GA88 -> G8 ***
 * macro reads p1 (GA88 at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_GA88_TO_G8_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_8_8(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_GA88_TO_G8(p1, p2) \
        GP_PIXEL_GA88_TO_G8_OFFSET(p1, 0, p2, 0)

/*** G8 -> G16 ***
 * macro reads p1 (G8 at bit-offset o1)
 * and writes to p2 (G16 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G8_TO_G16_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 16, p2,\
                GP_SCALE_VAL_8_16(GP_GET_BITS(0+o1, 8, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G8_TO_G16(p1, p2) \
        GP_PIXEL_G8_TO_G16_OFFSET(p1, 0, p2, 0)

/*** G16 -> G8 ***
 * macro reads p1 (G16 at bit-offset o1)
 * and writes to p2 (G8 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_G16_TO_G8_OFFSET(p1, o1, p2, o2) do { \
        /* V:=V */ GP_SET_BITS(0+o2, 8, p2,\
                GP_SCALE_VAL_16_8(GP_GET_BITS(0+o1, 16, p1))); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_G16_TO_G8(p1, p2) \
        GP_PIXEL_G16_TO_G8_OFFSET(p1, 0, p2, 0)


/*
 * Convert G8 to any other pixel type
 * Does not work on palette types at all (yet)
 */
gp_pixel gp_G8_to_pixel(gp_pixel pixel, gp_pixel_type type);

/*
 * Function converting to G8 from any other pixel type
 * Does not work on palette types at all (yet)
 */
gp_pixel gp_pixel_to_G8(gp_pixel pixel, gp_pixel_type type);


/* Experimental macros testing generated scripts */
/*** RGB565 -> RGBA8888 ***
 * macro reads p1 (RGB565 at bit-offset o1)
 * and writes to p2 (RGBA8888 at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGB565_TO_RGBA8888_OFFSET(p1, o1, p2, o2) do { \
        /* R:=R */ GP_SET_BITS(24+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(11+o1, 5, p1))); \
        /* G:=G */ GP_SET_BITS(16+o2, 8, p2,\
                GP_SCALE_VAL_6_8(GP_GET_BITS(5+o1, 6, p1))); \
        /* B:=B */ GP_SET_BITS(8+o2, 8, p2,\
                GP_SCALE_VAL_5_8(GP_GET_BITS(0+o1, 5, p1))); \
        /* A:=0xff */GP_SET_BITS(0+o2, 8, p2, 0xff); \
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGB565_TO_RGBA8888(p1, p2) \
        GP_PIXEL_RGB565_TO_RGBA8888_OFFSET(p1, 0, p2, 0)

/*** RGBA8888 -> G2_UB ***
 * macro reads p1 (RGBA8888 at bit-offset o1)
 * and writes to p2 (G2_UB at bit-offset o2)
 * the relevant part of p2 is assumed to be cleared (zero) */
#define GP_PIXEL_RGBA8888_TO_G2_UB_OFFSET(p1, o1, p2, o2) do { \
	/* V:=RGB_avg */ GP_SET_BITS(0+o2, 2, p2, ( \
                /* R */ GP_SCALE_VAL_8_2(GP_GET_BITS(24+o1, 8, p1)) + \
                /* G */ GP_SCALE_VAL_8_2(GP_GET_BITS(16+o1, 8, p1)) + \
                /* B */ GP_SCALE_VAL_8_2(GP_GET_BITS(8+o1, 8, p1)) + \
        0)/3);\
} while (0)

/* a version without offsets */
#define GP_PIXEL_RGBA8888_TO_G2_UB(p1, p2) \
        GP_PIXEL_RGBA8888_TO_G2_UB_OFFSET(p1, 0, p2, 0)

#endif /* GP_CONVERT_GEN_H */
