// SPDX-License-Identifier: GPL-2.1-or-later
/*
 * gp_convert_scale.gen.h
 *
 * GENERATED on 2023 10 30 20:24:52 from gp_convert_scale.gen.h.t
 *
 * DO NOT MODIFY THIS FILE DIRECTLY!
 */
#ifndef GP_CONVERT_SCALE_GEN_H
#define GP_CONVERT_SCALE_GEN_H

/*
 * Fast value scaling macros
 *
 * Copyright (C) 2011      Tomas Gavenciak <gavento@ucw.cz>
 * Copyright (C) 2013-2014 Cyril Hrubis <metan@ucw.cz>
 */


/*
 * Helper macros to transfer s1-bit value to s2-bit value.
 * Efficient and accurate for both up- and downscaling.
 * WARNING: GP_SCALE_VAL requires constants numbers as first two parameters
 */
#define GP_SCALE_VAL(s1, s2, val) ( GP_SCALE_VAL_##s1##_##s2(val) )

#define GP_SCALE_VAL_1_1(val) ((val) >> 0)
#define GP_SCALE_VAL_1_2(val) (((val) * (0+0x1+0x2)) >> 0)
#define GP_SCALE_VAL_1_3(val) (((val) * (0+0x1+0x2+0x4)) >> 0)
#define GP_SCALE_VAL_1_4(val) (((val) * (0+0x1+0x2+0x4+0x8)) >> 0)
#define GP_SCALE_VAL_1_5(val) (((val) * (0+0x1+0x2+0x4+0x8+0x10)) >> 0)
#define GP_SCALE_VAL_1_6(val) (((val) * (0+0x1+0x2+0x4+0x8+0x10+0x20)) >> 0)
#define GP_SCALE_VAL_1_7(val) (((val) * (0+0x1+0x2+0x4+0x8+0x10+0x20+0x40)) >> 0)
#define GP_SCALE_VAL_1_8(val) (((val) * (0+0x1+0x2+0x4+0x8+0x10+0x20+0x40+0x80)) >> 0)
#define GP_SCALE_VAL_1_9(val) (((val) * (0+0x1+0x2+0x4+0x8+0x10+0x20+0x40+0x80+0x100)) >> 0)
#define GP_SCALE_VAL_1_10(val) (((val) * (0+0x1+0x2+0x4+0x8+0x10+0x20+0x40+0x80+0x100+0x200)) >> 0)
#define GP_SCALE_VAL_1_11(val) (((val) * (0+0x1+0x2+0x4+0x8+0x10+0x20+0x40+0x80+0x100+0x200+0x400)) >> 0)
#define GP_SCALE_VAL_1_12(val) (((val) * (0+0x1+0x2+0x4+0x8+0x10+0x20+0x40+0x80+0x100+0x200+0x400+0x800)) >> 0)
#define GP_SCALE_VAL_1_13(val) (((val) * (0+0x1+0x2+0x4+0x8+0x10+0x20+0x40+0x80+0x100+0x200+0x400+0x800+0x1000)) >> 0)
#define GP_SCALE_VAL_1_14(val) (((val) * (0+0x1+0x2+0x4+0x8+0x10+0x20+0x40+0x80+0x100+0x200+0x400+0x800+0x1000+0x2000)) >> 0)
#define GP_SCALE_VAL_1_15(val) (((val) * (0+0x1+0x2+0x4+0x8+0x10+0x20+0x40+0x80+0x100+0x200+0x400+0x800+0x1000+0x2000+0x4000)) >> 0)
#define GP_SCALE_VAL_1_16(val) (((val) * (0+0x1+0x2+0x4+0x8+0x10+0x20+0x40+0x80+0x100+0x200+0x400+0x800+0x1000+0x2000+0x4000+0x8000)) >> 0)
#define GP_SCALE_VAL_2_1(val) ((val) >> 1)
#define GP_SCALE_VAL_2_2(val) ((val) >> 0)
#define GP_SCALE_VAL_2_3(val) (((val) * (0+0x1+0x4)) >> 1)
#define GP_SCALE_VAL_2_4(val) (((val) * (0+0x1+0x4)) >> 0)
#define GP_SCALE_VAL_2_5(val) (((val) * (0+0x1+0x4+0x10)) >> 1)
#define GP_SCALE_VAL_2_6(val) (((val) * (0+0x1+0x4+0x10)) >> 0)
#define GP_SCALE_VAL_2_7(val) (((val) * (0+0x1+0x4+0x10+0x40)) >> 1)
#define GP_SCALE_VAL_2_8(val) (((val) * (0+0x1+0x4+0x10+0x40)) >> 0)
#define GP_SCALE_VAL_2_9(val) (((val) * (0+0x1+0x4+0x10+0x40+0x100)) >> 1)
#define GP_SCALE_VAL_2_10(val) (((val) * (0+0x1+0x4+0x10+0x40+0x100)) >> 0)
#define GP_SCALE_VAL_2_11(val) (((val) * (0+0x1+0x4+0x10+0x40+0x100+0x400)) >> 1)
#define GP_SCALE_VAL_2_12(val) (((val) * (0+0x1+0x4+0x10+0x40+0x100+0x400)) >> 0)
#define GP_SCALE_VAL_2_13(val) (((val) * (0+0x1+0x4+0x10+0x40+0x100+0x400+0x1000)) >> 1)
#define GP_SCALE_VAL_2_14(val) (((val) * (0+0x1+0x4+0x10+0x40+0x100+0x400+0x1000)) >> 0)
#define GP_SCALE_VAL_2_15(val) (((val) * (0+0x1+0x4+0x10+0x40+0x100+0x400+0x1000+0x4000)) >> 1)
#define GP_SCALE_VAL_2_16(val) (((val) * (0+0x1+0x4+0x10+0x40+0x100+0x400+0x1000+0x4000)) >> 0)
#define GP_SCALE_VAL_3_1(val) ((val) >> 2)
#define GP_SCALE_VAL_3_2(val) ((val) >> 1)
#define GP_SCALE_VAL_3_3(val) ((val) >> 0)
#define GP_SCALE_VAL_3_4(val) (((val) * (0+0x1+0x8)) >> 2)
#define GP_SCALE_VAL_3_5(val) (((val) * (0+0x1+0x8)) >> 1)
#define GP_SCALE_VAL_3_6(val) (((val) * (0+0x1+0x8)) >> 0)
#define GP_SCALE_VAL_3_7(val) (((val) * (0+0x1+0x8+0x40)) >> 2)
#define GP_SCALE_VAL_3_8(val) (((val) * (0+0x1+0x8+0x40)) >> 1)
#define GP_SCALE_VAL_3_9(val) (((val) * (0+0x1+0x8+0x40)) >> 0)
#define GP_SCALE_VAL_3_10(val) (((val) * (0+0x1+0x8+0x40+0x200)) >> 2)
#define GP_SCALE_VAL_3_11(val) (((val) * (0+0x1+0x8+0x40+0x200)) >> 1)
#define GP_SCALE_VAL_3_12(val) (((val) * (0+0x1+0x8+0x40+0x200)) >> 0)
#define GP_SCALE_VAL_3_13(val) (((val) * (0+0x1+0x8+0x40+0x200+0x1000)) >> 2)
#define GP_SCALE_VAL_3_14(val) (((val) * (0+0x1+0x8+0x40+0x200+0x1000)) >> 1)
#define GP_SCALE_VAL_3_15(val) (((val) * (0+0x1+0x8+0x40+0x200+0x1000)) >> 0)
#define GP_SCALE_VAL_3_16(val) (((val) * (0+0x1+0x8+0x40+0x200+0x1000+0x8000)) >> 2)
#define GP_SCALE_VAL_4_1(val) ((val) >> 3)
#define GP_SCALE_VAL_4_2(val) ((val) >> 2)
#define GP_SCALE_VAL_4_3(val) ((val) >> 1)
#define GP_SCALE_VAL_4_4(val) ((val) >> 0)
#define GP_SCALE_VAL_4_5(val) (((val) * (0+0x1+0x10)) >> 3)
#define GP_SCALE_VAL_4_6(val) (((val) * (0+0x1+0x10)) >> 2)
#define GP_SCALE_VAL_4_7(val) (((val) * (0+0x1+0x10)) >> 1)
#define GP_SCALE_VAL_4_8(val) (((val) * (0+0x1+0x10)) >> 0)
#define GP_SCALE_VAL_4_9(val) (((val) * (0+0x1+0x10+0x100)) >> 3)
#define GP_SCALE_VAL_4_10(val) (((val) * (0+0x1+0x10+0x100)) >> 2)
#define GP_SCALE_VAL_4_11(val) (((val) * (0+0x1+0x10+0x100)) >> 1)
#define GP_SCALE_VAL_4_12(val) (((val) * (0+0x1+0x10+0x100)) >> 0)
#define GP_SCALE_VAL_4_13(val) (((val) * (0+0x1+0x10+0x100+0x1000)) >> 3)
#define GP_SCALE_VAL_4_14(val) (((val) * (0+0x1+0x10+0x100+0x1000)) >> 2)
#define GP_SCALE_VAL_4_15(val) (((val) * (0+0x1+0x10+0x100+0x1000)) >> 1)
#define GP_SCALE_VAL_4_16(val) (((val) * (0+0x1+0x10+0x100+0x1000)) >> 0)
#define GP_SCALE_VAL_5_1(val) ((val) >> 4)
#define GP_SCALE_VAL_5_2(val) ((val) >> 3)
#define GP_SCALE_VAL_5_3(val) ((val) >> 2)
#define GP_SCALE_VAL_5_4(val) ((val) >> 1)
#define GP_SCALE_VAL_5_5(val) ((val) >> 0)
#define GP_SCALE_VAL_5_6(val) (((val) * (0+0x1+0x20)) >> 4)
#define GP_SCALE_VAL_5_7(val) (((val) * (0+0x1+0x20)) >> 3)
#define GP_SCALE_VAL_5_8(val) (((val) * (0+0x1+0x20)) >> 2)
#define GP_SCALE_VAL_5_9(val) (((val) * (0+0x1+0x20)) >> 1)
#define GP_SCALE_VAL_5_10(val) (((val) * (0+0x1+0x20)) >> 0)
#define GP_SCALE_VAL_5_11(val) (((val) * (0+0x1+0x20+0x400)) >> 4)
#define GP_SCALE_VAL_5_12(val) (((val) * (0+0x1+0x20+0x400)) >> 3)
#define GP_SCALE_VAL_5_13(val) (((val) * (0+0x1+0x20+0x400)) >> 2)
#define GP_SCALE_VAL_5_14(val) (((val) * (0+0x1+0x20+0x400)) >> 1)
#define GP_SCALE_VAL_5_15(val) (((val) * (0+0x1+0x20+0x400)) >> 0)
#define GP_SCALE_VAL_5_16(val) (((val) * (0+0x1+0x20+0x400+0x8000)) >> 4)
#define GP_SCALE_VAL_6_1(val) ((val) >> 5)
#define GP_SCALE_VAL_6_2(val) ((val) >> 4)
#define GP_SCALE_VAL_6_3(val) ((val) >> 3)
#define GP_SCALE_VAL_6_4(val) ((val) >> 2)
#define GP_SCALE_VAL_6_5(val) ((val) >> 1)
#define GP_SCALE_VAL_6_6(val) ((val) >> 0)
#define GP_SCALE_VAL_6_7(val) (((val) * (0+0x1+0x40)) >> 5)
#define GP_SCALE_VAL_6_8(val) (((val) * (0+0x1+0x40)) >> 4)
#define GP_SCALE_VAL_6_9(val) (((val) * (0+0x1+0x40)) >> 3)
#define GP_SCALE_VAL_6_10(val) (((val) * (0+0x1+0x40)) >> 2)
#define GP_SCALE_VAL_6_11(val) (((val) * (0+0x1+0x40)) >> 1)
#define GP_SCALE_VAL_6_12(val) (((val) * (0+0x1+0x40)) >> 0)
#define GP_SCALE_VAL_6_13(val) (((val) * (0+0x1+0x40+0x1000)) >> 5)
#define GP_SCALE_VAL_6_14(val) (((val) * (0+0x1+0x40+0x1000)) >> 4)
#define GP_SCALE_VAL_6_15(val) (((val) * (0+0x1+0x40+0x1000)) >> 3)
#define GP_SCALE_VAL_6_16(val) (((val) * (0+0x1+0x40+0x1000)) >> 2)
#define GP_SCALE_VAL_7_1(val) ((val) >> 6)
#define GP_SCALE_VAL_7_2(val) ((val) >> 5)
#define GP_SCALE_VAL_7_3(val) ((val) >> 4)
#define GP_SCALE_VAL_7_4(val) ((val) >> 3)
#define GP_SCALE_VAL_7_5(val) ((val) >> 2)
#define GP_SCALE_VAL_7_6(val) ((val) >> 1)
#define GP_SCALE_VAL_7_7(val) ((val) >> 0)
#define GP_SCALE_VAL_7_8(val) (((val) * (0+0x1+0x80)) >> 6)
#define GP_SCALE_VAL_7_9(val) (((val) * (0+0x1+0x80)) >> 5)
#define GP_SCALE_VAL_7_10(val) (((val) * (0+0x1+0x80)) >> 4)
#define GP_SCALE_VAL_7_11(val) (((val) * (0+0x1+0x80)) >> 3)
#define GP_SCALE_VAL_7_12(val) (((val) * (0+0x1+0x80)) >> 2)
#define GP_SCALE_VAL_7_13(val) (((val) * (0+0x1+0x80)) >> 1)
#define GP_SCALE_VAL_7_14(val) (((val) * (0+0x1+0x80)) >> 0)
#define GP_SCALE_VAL_7_15(val) (((val) * (0+0x1+0x80+0x4000)) >> 6)
#define GP_SCALE_VAL_7_16(val) (((val) * (0+0x1+0x80+0x4000)) >> 5)
#define GP_SCALE_VAL_8_1(val) ((val) >> 7)
#define GP_SCALE_VAL_8_2(val) ((val) >> 6)
#define GP_SCALE_VAL_8_3(val) ((val) >> 5)
#define GP_SCALE_VAL_8_4(val) ((val) >> 4)
#define GP_SCALE_VAL_8_5(val) ((val) >> 3)
#define GP_SCALE_VAL_8_6(val) ((val) >> 2)
#define GP_SCALE_VAL_8_7(val) ((val) >> 1)
#define GP_SCALE_VAL_8_8(val) ((val) >> 0)
#define GP_SCALE_VAL_8_9(val) (((val) * (0+0x1+0x100)) >> 7)
#define GP_SCALE_VAL_8_10(val) (((val) * (0+0x1+0x100)) >> 6)
#define GP_SCALE_VAL_8_11(val) (((val) * (0+0x1+0x100)) >> 5)
#define GP_SCALE_VAL_8_12(val) (((val) * (0+0x1+0x100)) >> 4)
#define GP_SCALE_VAL_8_13(val) (((val) * (0+0x1+0x100)) >> 3)
#define GP_SCALE_VAL_8_14(val) (((val) * (0+0x1+0x100)) >> 2)
#define GP_SCALE_VAL_8_15(val) (((val) * (0+0x1+0x100)) >> 1)
#define GP_SCALE_VAL_8_16(val) (((val) * (0+0x1+0x100)) >> 0)
#define GP_SCALE_VAL_9_1(val) ((val) >> 8)
#define GP_SCALE_VAL_9_2(val) ((val) >> 7)
#define GP_SCALE_VAL_9_3(val) ((val) >> 6)
#define GP_SCALE_VAL_9_4(val) ((val) >> 5)
#define GP_SCALE_VAL_9_5(val) ((val) >> 4)
#define GP_SCALE_VAL_9_6(val) ((val) >> 3)
#define GP_SCALE_VAL_9_7(val) ((val) >> 2)
#define GP_SCALE_VAL_9_8(val) ((val) >> 1)
#define GP_SCALE_VAL_9_9(val) ((val) >> 0)
#define GP_SCALE_VAL_9_10(val) (((val) * (0+0x1+0x200)) >> 8)
#define GP_SCALE_VAL_9_11(val) (((val) * (0+0x1+0x200)) >> 7)
#define GP_SCALE_VAL_9_12(val) (((val) * (0+0x1+0x200)) >> 6)
#define GP_SCALE_VAL_9_13(val) (((val) * (0+0x1+0x200)) >> 5)
#define GP_SCALE_VAL_9_14(val) (((val) * (0+0x1+0x200)) >> 4)
#define GP_SCALE_VAL_9_15(val) (((val) * (0+0x1+0x200)) >> 3)
#define GP_SCALE_VAL_9_16(val) (((val) * (0+0x1+0x200)) >> 2)
#define GP_SCALE_VAL_10_1(val) ((val) >> 9)
#define GP_SCALE_VAL_10_2(val) ((val) >> 8)
#define GP_SCALE_VAL_10_3(val) ((val) >> 7)
#define GP_SCALE_VAL_10_4(val) ((val) >> 6)
#define GP_SCALE_VAL_10_5(val) ((val) >> 5)
#define GP_SCALE_VAL_10_6(val) ((val) >> 4)
#define GP_SCALE_VAL_10_7(val) ((val) >> 3)
#define GP_SCALE_VAL_10_8(val) ((val) >> 2)
#define GP_SCALE_VAL_10_9(val) ((val) >> 1)
#define GP_SCALE_VAL_10_10(val) ((val) >> 0)
#define GP_SCALE_VAL_10_11(val) (((val) * (0+0x1+0x400)) >> 9)
#define GP_SCALE_VAL_10_12(val) (((val) * (0+0x1+0x400)) >> 8)
#define GP_SCALE_VAL_10_13(val) (((val) * (0+0x1+0x400)) >> 7)
#define GP_SCALE_VAL_10_14(val) (((val) * (0+0x1+0x400)) >> 6)
#define GP_SCALE_VAL_10_15(val) (((val) * (0+0x1+0x400)) >> 5)
#define GP_SCALE_VAL_10_16(val) (((val) * (0+0x1+0x400)) >> 4)
#define GP_SCALE_VAL_11_1(val) ((val) >> 10)
#define GP_SCALE_VAL_11_2(val) ((val) >> 9)
#define GP_SCALE_VAL_11_3(val) ((val) >> 8)
#define GP_SCALE_VAL_11_4(val) ((val) >> 7)
#define GP_SCALE_VAL_11_5(val) ((val) >> 6)
#define GP_SCALE_VAL_11_6(val) ((val) >> 5)
#define GP_SCALE_VAL_11_7(val) ((val) >> 4)
#define GP_SCALE_VAL_11_8(val) ((val) >> 3)
#define GP_SCALE_VAL_11_9(val) ((val) >> 2)
#define GP_SCALE_VAL_11_10(val) ((val) >> 1)
#define GP_SCALE_VAL_11_11(val) ((val) >> 0)
#define GP_SCALE_VAL_11_12(val) (((val) * (0+0x1+0x800)) >> 10)
#define GP_SCALE_VAL_11_13(val) (((val) * (0+0x1+0x800)) >> 9)
#define GP_SCALE_VAL_11_14(val) (((val) * (0+0x1+0x800)) >> 8)
#define GP_SCALE_VAL_11_15(val) (((val) * (0+0x1+0x800)) >> 7)
#define GP_SCALE_VAL_11_16(val) (((val) * (0+0x1+0x800)) >> 6)
#define GP_SCALE_VAL_12_1(val) ((val) >> 11)
#define GP_SCALE_VAL_12_2(val) ((val) >> 10)
#define GP_SCALE_VAL_12_3(val) ((val) >> 9)
#define GP_SCALE_VAL_12_4(val) ((val) >> 8)
#define GP_SCALE_VAL_12_5(val) ((val) >> 7)
#define GP_SCALE_VAL_12_6(val) ((val) >> 6)
#define GP_SCALE_VAL_12_7(val) ((val) >> 5)
#define GP_SCALE_VAL_12_8(val) ((val) >> 4)
#define GP_SCALE_VAL_12_9(val) ((val) >> 3)
#define GP_SCALE_VAL_12_10(val) ((val) >> 2)
#define GP_SCALE_VAL_12_11(val) ((val) >> 1)
#define GP_SCALE_VAL_12_12(val) ((val) >> 0)
#define GP_SCALE_VAL_12_13(val) (((val) * (0+0x1+0x1000)) >> 11)
#define GP_SCALE_VAL_12_14(val) (((val) * (0+0x1+0x1000)) >> 10)
#define GP_SCALE_VAL_12_15(val) (((val) * (0+0x1+0x1000)) >> 9)
#define GP_SCALE_VAL_12_16(val) (((val) * (0+0x1+0x1000)) >> 8)
#define GP_SCALE_VAL_13_1(val) ((val) >> 12)
#define GP_SCALE_VAL_13_2(val) ((val) >> 11)
#define GP_SCALE_VAL_13_3(val) ((val) >> 10)
#define GP_SCALE_VAL_13_4(val) ((val) >> 9)
#define GP_SCALE_VAL_13_5(val) ((val) >> 8)
#define GP_SCALE_VAL_13_6(val) ((val) >> 7)
#define GP_SCALE_VAL_13_7(val) ((val) >> 6)
#define GP_SCALE_VAL_13_8(val) ((val) >> 5)
#define GP_SCALE_VAL_13_9(val) ((val) >> 4)
#define GP_SCALE_VAL_13_10(val) ((val) >> 3)
#define GP_SCALE_VAL_13_11(val) ((val) >> 2)
#define GP_SCALE_VAL_13_12(val) ((val) >> 1)
#define GP_SCALE_VAL_13_13(val) ((val) >> 0)
#define GP_SCALE_VAL_13_14(val) (((val) * (0+0x1+0x2000)) >> 12)
#define GP_SCALE_VAL_13_15(val) (((val) * (0+0x1+0x2000)) >> 11)
#define GP_SCALE_VAL_13_16(val) (((val) * (0+0x1+0x2000)) >> 10)
#define GP_SCALE_VAL_14_1(val) ((val) >> 13)
#define GP_SCALE_VAL_14_2(val) ((val) >> 12)
#define GP_SCALE_VAL_14_3(val) ((val) >> 11)
#define GP_SCALE_VAL_14_4(val) ((val) >> 10)
#define GP_SCALE_VAL_14_5(val) ((val) >> 9)
#define GP_SCALE_VAL_14_6(val) ((val) >> 8)
#define GP_SCALE_VAL_14_7(val) ((val) >> 7)
#define GP_SCALE_VAL_14_8(val) ((val) >> 6)
#define GP_SCALE_VAL_14_9(val) ((val) >> 5)
#define GP_SCALE_VAL_14_10(val) ((val) >> 4)
#define GP_SCALE_VAL_14_11(val) ((val) >> 3)
#define GP_SCALE_VAL_14_12(val) ((val) >> 2)
#define GP_SCALE_VAL_14_13(val) ((val) >> 1)
#define GP_SCALE_VAL_14_14(val) ((val) >> 0)
#define GP_SCALE_VAL_14_15(val) (((val) * (0+0x1+0x4000)) >> 13)
#define GP_SCALE_VAL_14_16(val) (((val) * (0+0x1+0x4000)) >> 12)
#define GP_SCALE_VAL_15_1(val) ((val) >> 14)
#define GP_SCALE_VAL_15_2(val) ((val) >> 13)
#define GP_SCALE_VAL_15_3(val) ((val) >> 12)
#define GP_SCALE_VAL_15_4(val) ((val) >> 11)
#define GP_SCALE_VAL_15_5(val) ((val) >> 10)
#define GP_SCALE_VAL_15_6(val) ((val) >> 9)
#define GP_SCALE_VAL_15_7(val) ((val) >> 8)
#define GP_SCALE_VAL_15_8(val) ((val) >> 7)
#define GP_SCALE_VAL_15_9(val) ((val) >> 6)
#define GP_SCALE_VAL_15_10(val) ((val) >> 5)
#define GP_SCALE_VAL_15_11(val) ((val) >> 4)
#define GP_SCALE_VAL_15_12(val) ((val) >> 3)
#define GP_SCALE_VAL_15_13(val) ((val) >> 2)
#define GP_SCALE_VAL_15_14(val) ((val) >> 1)
#define GP_SCALE_VAL_15_15(val) ((val) >> 0)
#define GP_SCALE_VAL_15_16(val) (((val) * (0+0x1+0x8000)) >> 14)
#define GP_SCALE_VAL_16_1(val) ((val) >> 15)
#define GP_SCALE_VAL_16_2(val) ((val) >> 14)
#define GP_SCALE_VAL_16_3(val) ((val) >> 13)
#define GP_SCALE_VAL_16_4(val) ((val) >> 12)
#define GP_SCALE_VAL_16_5(val) ((val) >> 11)
#define GP_SCALE_VAL_16_6(val) ((val) >> 10)
#define GP_SCALE_VAL_16_7(val) ((val) >> 9)
#define GP_SCALE_VAL_16_8(val) ((val) >> 8)
#define GP_SCALE_VAL_16_9(val) ((val) >> 7)
#define GP_SCALE_VAL_16_10(val) ((val) >> 6)
#define GP_SCALE_VAL_16_11(val) ((val) >> 5)
#define GP_SCALE_VAL_16_12(val) ((val) >> 4)
#define GP_SCALE_VAL_16_13(val) ((val) >> 3)
#define GP_SCALE_VAL_16_14(val) ((val) >> 2)
#define GP_SCALE_VAL_16_15(val) ((val) >> 1)
#define GP_SCALE_VAL_16_16(val) ((val) >> 0)
#define GP_SCALE_VAL_17_1(val) ((val) >> 16)
#define GP_SCALE_VAL_17_2(val) ((val) >> 15)
#define GP_SCALE_VAL_17_3(val) ((val) >> 14)
#define GP_SCALE_VAL_17_4(val) ((val) >> 13)
#define GP_SCALE_VAL_17_5(val) ((val) >> 12)
#define GP_SCALE_VAL_17_6(val) ((val) >> 11)
#define GP_SCALE_VAL_17_7(val) ((val) >> 10)
#define GP_SCALE_VAL_17_8(val) ((val) >> 9)
#define GP_SCALE_VAL_17_9(val) ((val) >> 8)
#define GP_SCALE_VAL_17_10(val) ((val) >> 7)
#define GP_SCALE_VAL_17_11(val) ((val) >> 6)
#define GP_SCALE_VAL_17_12(val) ((val) >> 5)
#define GP_SCALE_VAL_17_13(val) ((val) >> 4)
#define GP_SCALE_VAL_17_14(val) ((val) >> 3)
#define GP_SCALE_VAL_17_15(val) ((val) >> 2)
#define GP_SCALE_VAL_17_16(val) ((val) >> 1)
#define GP_SCALE_VAL_18_1(val) ((val) >> 17)
#define GP_SCALE_VAL_18_2(val) ((val) >> 16)
#define GP_SCALE_VAL_18_3(val) ((val) >> 15)
#define GP_SCALE_VAL_18_4(val) ((val) >> 14)
#define GP_SCALE_VAL_18_5(val) ((val) >> 13)
#define GP_SCALE_VAL_18_6(val) ((val) >> 12)
#define GP_SCALE_VAL_18_7(val) ((val) >> 11)
#define GP_SCALE_VAL_18_8(val) ((val) >> 10)
#define GP_SCALE_VAL_18_9(val) ((val) >> 9)
#define GP_SCALE_VAL_18_10(val) ((val) >> 8)
#define GP_SCALE_VAL_18_11(val) ((val) >> 7)
#define GP_SCALE_VAL_18_12(val) ((val) >> 6)
#define GP_SCALE_VAL_18_13(val) ((val) >> 5)
#define GP_SCALE_VAL_18_14(val) ((val) >> 4)
#define GP_SCALE_VAL_18_15(val) ((val) >> 3)
#define GP_SCALE_VAL_18_16(val) ((val) >> 2)
#define GP_SCALE_VAL_19_1(val) ((val) >> 18)
#define GP_SCALE_VAL_19_2(val) ((val) >> 17)
#define GP_SCALE_VAL_19_3(val) ((val) >> 16)
#define GP_SCALE_VAL_19_4(val) ((val) >> 15)
#define GP_SCALE_VAL_19_5(val) ((val) >> 14)
#define GP_SCALE_VAL_19_6(val) ((val) >> 13)
#define GP_SCALE_VAL_19_7(val) ((val) >> 12)
#define GP_SCALE_VAL_19_8(val) ((val) >> 11)
#define GP_SCALE_VAL_19_9(val) ((val) >> 10)
#define GP_SCALE_VAL_19_10(val) ((val) >> 9)
#define GP_SCALE_VAL_19_11(val) ((val) >> 8)
#define GP_SCALE_VAL_19_12(val) ((val) >> 7)
#define GP_SCALE_VAL_19_13(val) ((val) >> 6)
#define GP_SCALE_VAL_19_14(val) ((val) >> 5)
#define GP_SCALE_VAL_19_15(val) ((val) >> 4)
#define GP_SCALE_VAL_19_16(val) ((val) >> 3)
#define GP_SCALE_VAL_20_1(val) ((val) >> 19)
#define GP_SCALE_VAL_20_2(val) ((val) >> 18)
#define GP_SCALE_VAL_20_3(val) ((val) >> 17)
#define GP_SCALE_VAL_20_4(val) ((val) >> 16)
#define GP_SCALE_VAL_20_5(val) ((val) >> 15)
#define GP_SCALE_VAL_20_6(val) ((val) >> 14)
#define GP_SCALE_VAL_20_7(val) ((val) >> 13)
#define GP_SCALE_VAL_20_8(val) ((val) >> 12)
#define GP_SCALE_VAL_20_9(val) ((val) >> 11)
#define GP_SCALE_VAL_20_10(val) ((val) >> 10)
#define GP_SCALE_VAL_20_11(val) ((val) >> 9)
#define GP_SCALE_VAL_20_12(val) ((val) >> 8)
#define GP_SCALE_VAL_20_13(val) ((val) >> 7)
#define GP_SCALE_VAL_20_14(val) ((val) >> 6)
#define GP_SCALE_VAL_20_15(val) ((val) >> 5)
#define GP_SCALE_VAL_20_16(val) ((val) >> 4)
#define GP_SCALE_VAL_21_1(val) ((val) >> 20)
#define GP_SCALE_VAL_21_2(val) ((val) >> 19)
#define GP_SCALE_VAL_21_3(val) ((val) >> 18)
#define GP_SCALE_VAL_21_4(val) ((val) >> 17)
#define GP_SCALE_VAL_21_5(val) ((val) >> 16)
#define GP_SCALE_VAL_21_6(val) ((val) >> 15)
#define GP_SCALE_VAL_21_7(val) ((val) >> 14)
#define GP_SCALE_VAL_21_8(val) ((val) >> 13)
#define GP_SCALE_VAL_21_9(val) ((val) >> 12)
#define GP_SCALE_VAL_21_10(val) ((val) >> 11)
#define GP_SCALE_VAL_21_11(val) ((val) >> 10)
#define GP_SCALE_VAL_21_12(val) ((val) >> 9)
#define GP_SCALE_VAL_21_13(val) ((val) >> 8)
#define GP_SCALE_VAL_21_14(val) ((val) >> 7)
#define GP_SCALE_VAL_21_15(val) ((val) >> 6)
#define GP_SCALE_VAL_21_16(val) ((val) >> 5)
#define GP_SCALE_VAL_22_1(val) ((val) >> 21)
#define GP_SCALE_VAL_22_2(val) ((val) >> 20)
#define GP_SCALE_VAL_22_3(val) ((val) >> 19)
#define GP_SCALE_VAL_22_4(val) ((val) >> 18)
#define GP_SCALE_VAL_22_5(val) ((val) >> 17)
#define GP_SCALE_VAL_22_6(val) ((val) >> 16)
#define GP_SCALE_VAL_22_7(val) ((val) >> 15)
#define GP_SCALE_VAL_22_8(val) ((val) >> 14)
#define GP_SCALE_VAL_22_9(val) ((val) >> 13)
#define GP_SCALE_VAL_22_10(val) ((val) >> 12)
#define GP_SCALE_VAL_22_11(val) ((val) >> 11)
#define GP_SCALE_VAL_22_12(val) ((val) >> 10)
#define GP_SCALE_VAL_22_13(val) ((val) >> 9)
#define GP_SCALE_VAL_22_14(val) ((val) >> 8)
#define GP_SCALE_VAL_22_15(val) ((val) >> 7)
#define GP_SCALE_VAL_22_16(val) ((val) >> 6)
#define GP_SCALE_VAL_23_1(val) ((val) >> 22)
#define GP_SCALE_VAL_23_2(val) ((val) >> 21)
#define GP_SCALE_VAL_23_3(val) ((val) >> 20)
#define GP_SCALE_VAL_23_4(val) ((val) >> 19)
#define GP_SCALE_VAL_23_5(val) ((val) >> 18)
#define GP_SCALE_VAL_23_6(val) ((val) >> 17)
#define GP_SCALE_VAL_23_7(val) ((val) >> 16)
#define GP_SCALE_VAL_23_8(val) ((val) >> 15)
#define GP_SCALE_VAL_23_9(val) ((val) >> 14)
#define GP_SCALE_VAL_23_10(val) ((val) >> 13)
#define GP_SCALE_VAL_23_11(val) ((val) >> 12)
#define GP_SCALE_VAL_23_12(val) ((val) >> 11)
#define GP_SCALE_VAL_23_13(val) ((val) >> 10)
#define GP_SCALE_VAL_23_14(val) ((val) >> 9)
#define GP_SCALE_VAL_23_15(val) ((val) >> 8)
#define GP_SCALE_VAL_23_16(val) ((val) >> 7)
#define GP_SCALE_VAL_24_1(val) ((val) >> 23)
#define GP_SCALE_VAL_24_2(val) ((val) >> 22)
#define GP_SCALE_VAL_24_3(val) ((val) >> 21)
#define GP_SCALE_VAL_24_4(val) ((val) >> 20)
#define GP_SCALE_VAL_24_5(val) ((val) >> 19)
#define GP_SCALE_VAL_24_6(val) ((val) >> 18)
#define GP_SCALE_VAL_24_7(val) ((val) >> 17)
#define GP_SCALE_VAL_24_8(val) ((val) >> 16)
#define GP_SCALE_VAL_24_9(val) ((val) >> 15)
#define GP_SCALE_VAL_24_10(val) ((val) >> 14)
#define GP_SCALE_VAL_24_11(val) ((val) >> 13)
#define GP_SCALE_VAL_24_12(val) ((val) >> 12)
#define GP_SCALE_VAL_24_13(val) ((val) >> 11)
#define GP_SCALE_VAL_24_14(val) ((val) >> 10)
#define GP_SCALE_VAL_24_15(val) ((val) >> 9)
#define GP_SCALE_VAL_24_16(val) ((val) >> 8)
#define GP_SCALE_VAL_25_1(val) ((val) >> 24)
#define GP_SCALE_VAL_25_2(val) ((val) >> 23)
#define GP_SCALE_VAL_25_3(val) ((val) >> 22)
#define GP_SCALE_VAL_25_4(val) ((val) >> 21)
#define GP_SCALE_VAL_25_5(val) ((val) >> 20)
#define GP_SCALE_VAL_25_6(val) ((val) >> 19)
#define GP_SCALE_VAL_25_7(val) ((val) >> 18)
#define GP_SCALE_VAL_25_8(val) ((val) >> 17)
#define GP_SCALE_VAL_25_9(val) ((val) >> 16)
#define GP_SCALE_VAL_25_10(val) ((val) >> 15)
#define GP_SCALE_VAL_25_11(val) ((val) >> 14)
#define GP_SCALE_VAL_25_12(val) ((val) >> 13)
#define GP_SCALE_VAL_25_13(val) ((val) >> 12)
#define GP_SCALE_VAL_25_14(val) ((val) >> 11)
#define GP_SCALE_VAL_25_15(val) ((val) >> 10)
#define GP_SCALE_VAL_25_16(val) ((val) >> 9)
#define GP_SCALE_VAL_26_1(val) ((val) >> 25)
#define GP_SCALE_VAL_26_2(val) ((val) >> 24)
#define GP_SCALE_VAL_26_3(val) ((val) >> 23)
#define GP_SCALE_VAL_26_4(val) ((val) >> 22)
#define GP_SCALE_VAL_26_5(val) ((val) >> 21)
#define GP_SCALE_VAL_26_6(val) ((val) >> 20)
#define GP_SCALE_VAL_26_7(val) ((val) >> 19)
#define GP_SCALE_VAL_26_8(val) ((val) >> 18)
#define GP_SCALE_VAL_26_9(val) ((val) >> 17)
#define GP_SCALE_VAL_26_10(val) ((val) >> 16)
#define GP_SCALE_VAL_26_11(val) ((val) >> 15)
#define GP_SCALE_VAL_26_12(val) ((val) >> 14)
#define GP_SCALE_VAL_26_13(val) ((val) >> 13)
#define GP_SCALE_VAL_26_14(val) ((val) >> 12)
#define GP_SCALE_VAL_26_15(val) ((val) >> 11)
#define GP_SCALE_VAL_26_16(val) ((val) >> 10)
#define GP_SCALE_VAL_27_1(val) ((val) >> 26)
#define GP_SCALE_VAL_27_2(val) ((val) >> 25)
#define GP_SCALE_VAL_27_3(val) ((val) >> 24)
#define GP_SCALE_VAL_27_4(val) ((val) >> 23)
#define GP_SCALE_VAL_27_5(val) ((val) >> 22)
#define GP_SCALE_VAL_27_6(val) ((val) >> 21)
#define GP_SCALE_VAL_27_7(val) ((val) >> 20)
#define GP_SCALE_VAL_27_8(val) ((val) >> 19)
#define GP_SCALE_VAL_27_9(val) ((val) >> 18)
#define GP_SCALE_VAL_27_10(val) ((val) >> 17)
#define GP_SCALE_VAL_27_11(val) ((val) >> 16)
#define GP_SCALE_VAL_27_12(val) ((val) >> 15)
#define GP_SCALE_VAL_27_13(val) ((val) >> 14)
#define GP_SCALE_VAL_27_14(val) ((val) >> 13)
#define GP_SCALE_VAL_27_15(val) ((val) >> 12)
#define GP_SCALE_VAL_27_16(val) ((val) >> 11)
#define GP_SCALE_VAL_28_1(val) ((val) >> 27)
#define GP_SCALE_VAL_28_2(val) ((val) >> 26)
#define GP_SCALE_VAL_28_3(val) ((val) >> 25)
#define GP_SCALE_VAL_28_4(val) ((val) >> 24)
#define GP_SCALE_VAL_28_5(val) ((val) >> 23)
#define GP_SCALE_VAL_28_6(val) ((val) >> 22)
#define GP_SCALE_VAL_28_7(val) ((val) >> 21)
#define GP_SCALE_VAL_28_8(val) ((val) >> 20)
#define GP_SCALE_VAL_28_9(val) ((val) >> 19)
#define GP_SCALE_VAL_28_10(val) ((val) >> 18)
#define GP_SCALE_VAL_28_11(val) ((val) >> 17)
#define GP_SCALE_VAL_28_12(val) ((val) >> 16)
#define GP_SCALE_VAL_28_13(val) ((val) >> 15)
#define GP_SCALE_VAL_28_14(val) ((val) >> 14)
#define GP_SCALE_VAL_28_15(val) ((val) >> 13)
#define GP_SCALE_VAL_28_16(val) ((val) >> 12)
#define GP_SCALE_VAL_29_1(val) ((val) >> 28)
#define GP_SCALE_VAL_29_2(val) ((val) >> 27)
#define GP_SCALE_VAL_29_3(val) ((val) >> 26)
#define GP_SCALE_VAL_29_4(val) ((val) >> 25)
#define GP_SCALE_VAL_29_5(val) ((val) >> 24)
#define GP_SCALE_VAL_29_6(val) ((val) >> 23)
#define GP_SCALE_VAL_29_7(val) ((val) >> 22)
#define GP_SCALE_VAL_29_8(val) ((val) >> 21)
#define GP_SCALE_VAL_29_9(val) ((val) >> 20)
#define GP_SCALE_VAL_29_10(val) ((val) >> 19)
#define GP_SCALE_VAL_29_11(val) ((val) >> 18)
#define GP_SCALE_VAL_29_12(val) ((val) >> 17)
#define GP_SCALE_VAL_29_13(val) ((val) >> 16)
#define GP_SCALE_VAL_29_14(val) ((val) >> 15)
#define GP_SCALE_VAL_29_15(val) ((val) >> 14)
#define GP_SCALE_VAL_29_16(val) ((val) >> 13)
#define GP_SCALE_VAL_30_1(val) ((val) >> 29)
#define GP_SCALE_VAL_30_2(val) ((val) >> 28)
#define GP_SCALE_VAL_30_3(val) ((val) >> 27)
#define GP_SCALE_VAL_30_4(val) ((val) >> 26)
#define GP_SCALE_VAL_30_5(val) ((val) >> 25)
#define GP_SCALE_VAL_30_6(val) ((val) >> 24)
#define GP_SCALE_VAL_30_7(val) ((val) >> 23)
#define GP_SCALE_VAL_30_8(val) ((val) >> 22)
#define GP_SCALE_VAL_30_9(val) ((val) >> 21)
#define GP_SCALE_VAL_30_10(val) ((val) >> 20)
#define GP_SCALE_VAL_30_11(val) ((val) >> 19)
#define GP_SCALE_VAL_30_12(val) ((val) >> 18)
#define GP_SCALE_VAL_30_13(val) ((val) >> 17)
#define GP_SCALE_VAL_30_14(val) ((val) >> 16)
#define GP_SCALE_VAL_30_15(val) ((val) >> 15)
#define GP_SCALE_VAL_30_16(val) ((val) >> 14)
#define GP_SCALE_VAL_31_1(val) ((val) >> 30)
#define GP_SCALE_VAL_31_2(val) ((val) >> 29)
#define GP_SCALE_VAL_31_3(val) ((val) >> 28)
#define GP_SCALE_VAL_31_4(val) ((val) >> 27)
#define GP_SCALE_VAL_31_5(val) ((val) >> 26)
#define GP_SCALE_VAL_31_6(val) ((val) >> 25)
#define GP_SCALE_VAL_31_7(val) ((val) >> 24)
#define GP_SCALE_VAL_31_8(val) ((val) >> 23)
#define GP_SCALE_VAL_31_9(val) ((val) >> 22)
#define GP_SCALE_VAL_31_10(val) ((val) >> 21)
#define GP_SCALE_VAL_31_11(val) ((val) >> 20)
#define GP_SCALE_VAL_31_12(val) ((val) >> 19)
#define GP_SCALE_VAL_31_13(val) ((val) >> 18)
#define GP_SCALE_VAL_31_14(val) ((val) >> 17)
#define GP_SCALE_VAL_31_15(val) ((val) >> 16)
#define GP_SCALE_VAL_31_16(val) ((val) >> 15)
#define GP_SCALE_VAL_32_1(val) ((val) >> 31)
#define GP_SCALE_VAL_32_2(val) ((val) >> 30)
#define GP_SCALE_VAL_32_3(val) ((val) >> 29)
#define GP_SCALE_VAL_32_4(val) ((val) >> 28)
#define GP_SCALE_VAL_32_5(val) ((val) >> 27)
#define GP_SCALE_VAL_32_6(val) ((val) >> 26)
#define GP_SCALE_VAL_32_7(val) ((val) >> 25)
#define GP_SCALE_VAL_32_8(val) ((val) >> 24)
#define GP_SCALE_VAL_32_9(val) ((val) >> 23)
#define GP_SCALE_VAL_32_10(val) ((val) >> 22)
#define GP_SCALE_VAL_32_11(val) ((val) >> 21)
#define GP_SCALE_VAL_32_12(val) ((val) >> 20)
#define GP_SCALE_VAL_32_13(val) ((val) >> 19)
#define GP_SCALE_VAL_32_14(val) ((val) >> 18)
#define GP_SCALE_VAL_32_15(val) ((val) >> 17)
#define GP_SCALE_VAL_32_16(val) ((val) >> 16)
#endif /* GP_CONVERT_SCALE_GEN_H */
