// SPDX-License-Identifier: GPL-2.1-or-later
/*
 * gp_gamma_correction.gen.h
 *
 * GENERATED on 2023 10 30 20:24:52 from gp_gamma_correction.gen.h.t
 *
 * DO NOT MODIFY THIS FILE DIRECTLY!
 */
#ifndef GP_GAMMA_CORRECTION_GEN_H
#define GP_GAMMA_CORRECTION_GEN_H

/*
 * Gamma corrections
 *
 * Copyright (C) 2012-2014 Cyril Hrubis <metan@ucw.cz>
 */

extern uint16_t *gp_gamma8_linear10;
extern uint8_t  *gp_linear10_gamma8;

static inline uint16_t gp_gamma1_to_linear10(uint8_t val)
{
	return gp_gamma8_linear10[val<<7];
}

static inline uint16_t gp_gamma2_to_linear10(uint8_t val)
{
	return gp_gamma8_linear10[val<<6];
}

static inline uint16_t gp_gamma3_to_linear10(uint8_t val)
{
	return gp_gamma8_linear10[val<<5];
}

static inline uint16_t gp_gamma4_to_linear10(uint8_t val)
{
	return gp_gamma8_linear10[val<<4];
}

static inline uint16_t gp_gamma5_to_linear10(uint8_t val)
{
	return gp_gamma8_linear10[val<<3];
}

static inline uint16_t gp_gamma6_to_linear10(uint8_t val)
{
	return gp_gamma8_linear10[val<<2];
}

static inline uint16_t gp_gamma7_to_linear10(uint8_t val)
{
	return gp_gamma8_linear10[val<<1];
}

static inline uint16_t gp_gamma8_to_linear10(uint8_t val)
{
	return gp_gamma8_linear10[val<<0];
}

static inline uint8_t gp_linear10_to_gamma1(uint16_t val)
{
	return (gp_linear10_gamma8[val] + 64)>>7;
}

static inline uint8_t gp_linear16_to_gamma1(uint16_t val)
{
	return (gp_linear10_gamma8[val>>6] + 64)>>7;
}

static inline uint8_t gp_linear10_to_gamma2(uint16_t val)
{
	return (gp_linear10_gamma8[val] + 32)>>6;
}

static inline uint8_t gp_linear16_to_gamma2(uint16_t val)
{
	return (gp_linear10_gamma8[val>>6] + 32)>>6;
}

static inline uint8_t gp_linear10_to_gamma3(uint16_t val)
{
	return (gp_linear10_gamma8[val] + 16)>>5;
}

static inline uint8_t gp_linear16_to_gamma3(uint16_t val)
{
	return (gp_linear10_gamma8[val>>6] + 16)>>5;
}

static inline uint8_t gp_linear10_to_gamma4(uint16_t val)
{
	return (gp_linear10_gamma8[val] + 8)>>4;
}

static inline uint8_t gp_linear16_to_gamma4(uint16_t val)
{
	return (gp_linear10_gamma8[val>>6] + 8)>>4;
}

static inline uint8_t gp_linear10_to_gamma5(uint16_t val)
{
	return (gp_linear10_gamma8[val] + 4)>>3;
}

static inline uint8_t gp_linear16_to_gamma5(uint16_t val)
{
	return (gp_linear10_gamma8[val>>6] + 4)>>3;
}

static inline uint8_t gp_linear10_to_gamma6(uint16_t val)
{
	return (gp_linear10_gamma8[val] + 2)>>2;
}

static inline uint8_t gp_linear16_to_gamma6(uint16_t val)
{
	return (gp_linear10_gamma8[val>>6] + 2)>>2;
}

static inline uint8_t gp_linear10_to_gamma7(uint16_t val)
{
	return (gp_linear10_gamma8[val] + 1)>>1;
}

static inline uint8_t gp_linear16_to_gamma7(uint16_t val)
{
	return (gp_linear10_gamma8[val>>6] + 1)>>1;
}

static inline uint8_t gp_linear10_to_gamma8(uint16_t val)
{
	return (gp_linear10_gamma8[val] + 0)>>0;
}

static inline uint8_t gp_linear16_to_gamma8(uint16_t val)
{
	return (gp_linear10_gamma8[val>>6] + 0)>>0;
}

#endif /* GP_GAMMA_CORRECTION_GEN_H */
