// SPDX-License-Identifier: GPL-2.1-or-later
/*
 * gp_write_pixels.gen.h
 *
 * GENERATED on 2023 10 30 20:24:52 from gp_write_pixels.gen.h.t
 *
 * DO NOT MODIFY THIS FILE DIRECTLY!
 */
#ifndef GP_WRITE_PIXELS_GEN_H
#define GP_WRITE_PIXELS_GEN_H

/*
 * Write Pixels generated header
 *
 * Copyright (C) 2009-2023 Cyril Hrubis <metan@ucw.cz>
 */

#include <stddef.h>
#include <stdint.h>

/*
 * These functions writes cnt pixels using value val starting at start address
 * and additionally (for pixel sizes that are not aligned to the whole bytes)
 * at off offset in the first byte (i.e. byte at the start address).
 *
 * @start A starting byte in the buffer
 * @off Number of pixels to skip in the first byte
 * @cnt A number of pixels to write
 * @val A value to be written.
 */
void gp_write_pixels_1BPP_DB(void *start, uint8_t off,
                             size_t cnt, unsigned int val);

void gp_write_pixels_1BPP_UB(void *start, uint8_t off,
                             size_t cnt, unsigned int val);

void gp_write_pixels_2BPP_DB(void *start, uint8_t off,
                             size_t cnt, unsigned int val);

void gp_write_pixels_2BPP_UB(void *start, uint8_t off,
                             size_t cnt, unsigned int val);

void gp_write_pixels_4BPP_DB(void *start, uint8_t off,
                             size_t cnt, unsigned int val);

void gp_write_pixels_4BPP_UB(void *start, uint8_t off,
                             size_t cnt, unsigned int val);

void gp_write_pixels_8BPP(void *start, size_t cnt, unsigned int val);

void gp_write_pixels_16BPP(void *start, size_t cnt, unsigned int val);

void gp_write_pixels_24BPP(void *start, size_t cnt, unsigned int val);

void gp_write_pixels_32BPP(void *start, size_t cnt, unsigned int val);

#endif /* GP_WRITE_PIXELS_GEN_H */
