// SPDX-License-Identifier: GPL-2.1-or-later
/*
 * gp_point.gen.h
 *
 * GENERATED on 2023 10 30 20:24:52 from gp_point.gen.h.t
 *
 * DO NOT MODIFY THIS FILE DIRECTLY!
 */
#ifndef GP_POINT_GEN_H
#define GP_POINT_GEN_H

/*
 * Point filter prototypes.
 *
 * Copyright (C) 2018 Cyril Hrubis <metan@ucw.cz>
 */
#include <filters/gp_filter.h>


/*** Function prototypes for brightness filter ***/

int gp_filter_brightness_ex(const gp_pixmap *src,
                          gp_coord x_src, gp_coord y_src,
			  gp_size w_src, gp_size h_src,
                          gp_pixmap *dst,
                          gp_coord x_dst, gp_coord y_dst,
                          float p, gp_progress_cb *callback);

gp_pixmap *gp_filter_brightness_ex_alloc(const gp_pixmap *src,
                                       gp_coord x_src, gp_coord y_src,
                                       gp_size w_src, gp_size h_src,
                                       float p, gp_progress_cb *callback);

static inline int gp_filter_brightness(const gp_pixmap *src, gp_pixmap *dst,
                                     float p,gp_progress_cb *callback)
{
	return gp_filter_brightness_ex(src, 0, 0, src->w, src->h,
	                             dst, 0, 0, p, callback);
}

static inline gp_pixmap *gp_filter_brightness_alloc(const gp_pixmap *src,
                                                  float p,gp_progress_cb *callback)
{
	return gp_filter_brightness_ex_alloc(src, 0, 0, src->w, src->h,
	                                   p, callback);
}

/*** Function prototypes for contrast filter ***/

int gp_filter_contrast_ex(const gp_pixmap *src,
                          gp_coord x_src, gp_coord y_src,
			  gp_size w_src, gp_size h_src,
                          gp_pixmap *dst,
                          gp_coord x_dst, gp_coord y_dst,
                          float p, gp_progress_cb *callback);

gp_pixmap *gp_filter_contrast_ex_alloc(const gp_pixmap *src,
                                       gp_coord x_src, gp_coord y_src,
                                       gp_size w_src, gp_size h_src,
                                       float p, gp_progress_cb *callback);

static inline int gp_filter_contrast(const gp_pixmap *src, gp_pixmap *dst,
                                     float p,gp_progress_cb *callback)
{
	return gp_filter_contrast_ex(src, 0, 0, src->w, src->h,
	                             dst, 0, 0, p, callback);
}

static inline gp_pixmap *gp_filter_contrast_alloc(const gp_pixmap *src,
                                                  float p,gp_progress_cb *callback)
{
	return gp_filter_contrast_ex_alloc(src, 0, 0, src->w, src->h,
	                                   p, callback);
}

/*** Function prototypes for brightness_contrast filter ***/

int gp_filter_brightness_contrast_ex(const gp_pixmap *src,
                          gp_coord x_src, gp_coord y_src,
			  gp_size w_src, gp_size h_src,
                          gp_pixmap *dst,
                          gp_coord x_dst, gp_coord y_dst,
                          float b, float c, gp_progress_cb *callback);

gp_pixmap *gp_filter_brightness_contrast_ex_alloc(const gp_pixmap *src,
                                       gp_coord x_src, gp_coord y_src,
                                       gp_size w_src, gp_size h_src,
                                       float b, float c, gp_progress_cb *callback);

static inline int gp_filter_brightness_contrast(const gp_pixmap *src, gp_pixmap *dst,
                                     float b, float c,gp_progress_cb *callback)
{
	return gp_filter_brightness_contrast_ex(src, 0, 0, src->w, src->h,
	                             dst, 0, 0, b, c, callback);
}

static inline gp_pixmap *gp_filter_brightness_contrast_alloc(const gp_pixmap *src,
                                                  float b, float c,gp_progress_cb *callback)
{
	return gp_filter_brightness_contrast_ex_alloc(src, 0, 0, src->w, src->h,
	                                   b, c, callback);
}

/*** Function prototypes for posterize filter ***/

int gp_filter_posterize_ex(const gp_pixmap *src,
                          gp_coord x_src, gp_coord y_src,
			  gp_size w_src, gp_size h_src,
                          gp_pixmap *dst,
                          gp_coord x_dst, gp_coord y_dst,
                          unsigned int steps, gp_progress_cb *callback);

gp_pixmap *gp_filter_posterize_ex_alloc(const gp_pixmap *src,
                                       gp_coord x_src, gp_coord y_src,
                                       gp_size w_src, gp_size h_src,
                                       unsigned int steps, gp_progress_cb *callback);

static inline int gp_filter_posterize(const gp_pixmap *src, gp_pixmap *dst,
                                     unsigned int steps,gp_progress_cb *callback)
{
	return gp_filter_posterize_ex(src, 0, 0, src->w, src->h,
	                             dst, 0, 0, steps, callback);
}

static inline gp_pixmap *gp_filter_posterize_alloc(const gp_pixmap *src,
                                                  unsigned int steps,gp_progress_cb *callback)
{
	return gp_filter_posterize_ex_alloc(src, 0, 0, src->w, src->h,
	                                   steps, callback);
}

/*** Function prototypes for invert filter ***/

int gp_filter_invert_ex(const gp_pixmap *src,
                          gp_coord x_src, gp_coord y_src,
			  gp_size w_src, gp_size h_src,
                          gp_pixmap *dst,
                          gp_coord x_dst, gp_coord y_dst,
                           gp_progress_cb *callback);

gp_pixmap *gp_filter_invert_ex_alloc(const gp_pixmap *src,
                                       gp_coord x_src, gp_coord y_src,
                                       gp_size w_src, gp_size h_src,
                                        gp_progress_cb *callback);

static inline int gp_filter_invert(const gp_pixmap *src, gp_pixmap *dst,
                                     gp_progress_cb *callback)
{
	return gp_filter_invert_ex(src, 0, 0, src->w, src->h,
	                             dst, 0, 0,  callback);
}

static inline gp_pixmap *gp_filter_invert_alloc(const gp_pixmap *src,
                                                  gp_progress_cb *callback)
{
	return gp_filter_invert_ex_alloc(src, 0, 0, src->w, src->h,
	                                    callback);
}

#endif /* GP_POINT_GEN_H */
