// SPDX-License-Identifier: GPL-2.1-or-later
/*
 * gp_loaders.gen.h
 *
 * GENERATED on 2023 10 30 20:24:52 from gp_loaders.gen.h.t
 *
 * DO NOT MODIFY THIS FILE DIRECTLY!
 */
#ifndef GP_LOADERS_GEN_H
#define GP_LOADERS_GEN_H

/*
 * Inline functions for loading and saving various pixmap formats.
 *
 * Copyright (C) 2017 Cyril Hrubis <metan@ucw.cz>
 */
#include <loaders/gp_loader.h>


/*** Function prototypes for bmp ***/

extern const gp_loader gp_bmp;

int gp_match_bmp(const void *buf);

int gp_read_bmp_ex(gp_io *io, gp_pixmap **img, gp_storage *storage,
                   gp_progress_cb *callback);

static inline gp_pixmap *gp_load_bmp(const char *src_path,
                                     gp_progress_cb *callback)
{
        return gp_loader_load_image(&gp_bmp, src_path, callback);
}

static inline gp_pixmap *gp_read_bmp(gp_io *io, gp_progress_cb *callback)
{
        return gp_loader_read_image(&gp_bmp, io, callback);
}

int gp_write_bmp(const gp_pixmap *src, gp_io *io,
                 gp_progress_cb *callback);

static inline int gp_save_bmp(const gp_pixmap *src, const char *dst_path,
                              gp_progress_cb *callback)
{
	return gp_loader_save_image(&gp_bmp, src, dst_path, callback);
}

/*** Function prototypes for jpg ***/

extern const gp_loader gp_jpg;

int gp_match_jpg(const void *buf);

int gp_read_jpg_ex(gp_io *io, gp_pixmap **img, gp_storage *storage,
                   gp_progress_cb *callback);

static inline gp_pixmap *gp_load_jpg(const char *src_path,
                                     gp_progress_cb *callback)
{
        return gp_loader_load_image(&gp_jpg, src_path, callback);
}

static inline gp_pixmap *gp_read_jpg(gp_io *io, gp_progress_cb *callback)
{
        return gp_loader_read_image(&gp_jpg, io, callback);
}

int gp_write_jpg(const gp_pixmap *src, gp_io *io,
                 gp_progress_cb *callback);

static inline int gp_save_jpg(const gp_pixmap *src, const char *dst_path,
                              gp_progress_cb *callback)
{
	return gp_loader_save_image(&gp_jpg, src, dst_path, callback);
}

/*** Function prototypes for png ***/

extern const gp_loader gp_png;

int gp_match_png(const void *buf);

int gp_read_png_ex(gp_io *io, gp_pixmap **img, gp_storage *storage,
                   gp_progress_cb *callback);

static inline gp_pixmap *gp_load_png(const char *src_path,
                                     gp_progress_cb *callback)
{
        return gp_loader_load_image(&gp_png, src_path, callback);
}

static inline gp_pixmap *gp_read_png(gp_io *io, gp_progress_cb *callback)
{
        return gp_loader_read_image(&gp_png, io, callback);
}

int gp_write_png(const gp_pixmap *src, gp_io *io,
                 gp_progress_cb *callback);

static inline int gp_save_png(const gp_pixmap *src, const char *dst_path,
                              gp_progress_cb *callback)
{
	return gp_loader_save_image(&gp_png, src, dst_path, callback);
}

/*** Function prototypes for tiff ***/

extern const gp_loader gp_tiff;

int gp_match_tiff(const void *buf);

int gp_read_tiff_ex(gp_io *io, gp_pixmap **img, gp_storage *storage,
                   gp_progress_cb *callback);

static inline gp_pixmap *gp_load_tiff(const char *src_path,
                                     gp_progress_cb *callback)
{
        return gp_loader_load_image(&gp_tiff, src_path, callback);
}

static inline gp_pixmap *gp_read_tiff(gp_io *io, gp_progress_cb *callback)
{
        return gp_loader_read_image(&gp_tiff, io, callback);
}

int gp_write_tiff(const gp_pixmap *src, gp_io *io,
                 gp_progress_cb *callback);

static inline int gp_save_tiff(const gp_pixmap *src, const char *dst_path,
                              gp_progress_cb *callback)
{
	return gp_loader_save_image(&gp_tiff, src, dst_path, callback);
}

/*** Function prototypes for pbm ***/

extern const gp_loader gp_pbm;

int gp_match_pbm(const void *buf);

int gp_read_pbm_ex(gp_io *io, gp_pixmap **img, gp_storage *storage,
                   gp_progress_cb *callback);

static inline gp_pixmap *gp_load_pbm(const char *src_path,
                                     gp_progress_cb *callback)
{
        return gp_loader_load_image(&gp_pbm, src_path, callback);
}

static inline gp_pixmap *gp_read_pbm(gp_io *io, gp_progress_cb *callback)
{
        return gp_loader_read_image(&gp_pbm, io, callback);
}

int gp_write_pbm(const gp_pixmap *src, gp_io *io,
                 gp_progress_cb *callback);

static inline int gp_save_pbm(const gp_pixmap *src, const char *dst_path,
                              gp_progress_cb *callback)
{
	return gp_loader_save_image(&gp_pbm, src, dst_path, callback);
}

/*** Function prototypes for pgm ***/

extern const gp_loader gp_pgm;

int gp_match_pgm(const void *buf);

int gp_read_pgm_ex(gp_io *io, gp_pixmap **img, gp_storage *storage,
                   gp_progress_cb *callback);

static inline gp_pixmap *gp_load_pgm(const char *src_path,
                                     gp_progress_cb *callback)
{
        return gp_loader_load_image(&gp_pgm, src_path, callback);
}

static inline gp_pixmap *gp_read_pgm(gp_io *io, gp_progress_cb *callback)
{
        return gp_loader_read_image(&gp_pgm, io, callback);
}

int gp_write_pgm(const gp_pixmap *src, gp_io *io,
                 gp_progress_cb *callback);

static inline int gp_save_pgm(const gp_pixmap *src, const char *dst_path,
                              gp_progress_cb *callback)
{
	return gp_loader_save_image(&gp_pgm, src, dst_path, callback);
}

/*** Function prototypes for ppm ***/

extern const gp_loader gp_ppm;

int gp_match_ppm(const void *buf);

int gp_read_ppm_ex(gp_io *io, gp_pixmap **img, gp_storage *storage,
                   gp_progress_cb *callback);

static inline gp_pixmap *gp_load_ppm(const char *src_path,
                                     gp_progress_cb *callback)
{
        return gp_loader_load_image(&gp_ppm, src_path, callback);
}

static inline gp_pixmap *gp_read_ppm(gp_io *io, gp_progress_cb *callback)
{
        return gp_loader_read_image(&gp_ppm, io, callback);
}

int gp_write_ppm(const gp_pixmap *src, gp_io *io,
                 gp_progress_cb *callback);

static inline int gp_save_ppm(const gp_pixmap *src, const char *dst_path,
                              gp_progress_cb *callback)
{
	return gp_loader_save_image(&gp_ppm, src, dst_path, callback);
}

/*** Function prototypes for pnm ***/

extern const gp_loader gp_pnm;

int gp_match_pnm(const void *buf);

int gp_read_pnm_ex(gp_io *io, gp_pixmap **img, gp_storage *storage,
                   gp_progress_cb *callback);

static inline gp_pixmap *gp_load_pnm(const char *src_path,
                                     gp_progress_cb *callback)
{
        return gp_loader_load_image(&gp_pnm, src_path, callback);
}

static inline gp_pixmap *gp_read_pnm(gp_io *io, gp_progress_cb *callback)
{
        return gp_loader_read_image(&gp_pnm, io, callback);
}

int gp_write_pnm(const gp_pixmap *src, gp_io *io,
                 gp_progress_cb *callback);

static inline int gp_save_pnm(const gp_pixmap *src, const char *dst_path,
                              gp_progress_cb *callback)
{
	return gp_loader_save_image(&gp_pnm, src, dst_path, callback);
}

/*** Function prototypes for ico ***/

extern const gp_loader gp_ico;

int gp_match_ico(const void *buf);

int gp_read_ico_ex(gp_io *io, gp_pixmap **img, gp_storage *storage,
                   gp_progress_cb *callback);

static inline gp_pixmap *gp_load_ico(const char *src_path,
                                     gp_progress_cb *callback)
{
        return gp_loader_load_image(&gp_ico, src_path, callback);
}

static inline gp_pixmap *gp_read_ico(gp_io *io, gp_progress_cb *callback)
{
        return gp_loader_read_image(&gp_ico, io, callback);
}
/*** Function prototypes for webp ***/

extern const gp_loader gp_webp;

int gp_match_webp(const void *buf);

int gp_read_webp_ex(gp_io *io, gp_pixmap **img, gp_storage *storage,
                   gp_progress_cb *callback);

static inline gp_pixmap *gp_load_webp(const char *src_path,
                                     gp_progress_cb *callback)
{
        return gp_loader_load_image(&gp_webp, src_path, callback);
}

static inline gp_pixmap *gp_read_webp(gp_io *io, gp_progress_cb *callback)
{
        return gp_loader_read_image(&gp_webp, io, callback);
}
/*** Function prototypes for jp2 ***/

extern const gp_loader gp_jp2;

int gp_match_jp2(const void *buf);

int gp_read_jp2_ex(gp_io *io, gp_pixmap **img, gp_storage *storage,
                   gp_progress_cb *callback);

static inline gp_pixmap *gp_load_jp2(const char *src_path,
                                     gp_progress_cb *callback)
{
        return gp_loader_load_image(&gp_jp2, src_path, callback);
}

static inline gp_pixmap *gp_read_jp2(gp_io *io, gp_progress_cb *callback)
{
        return gp_loader_read_image(&gp_jp2, io, callback);
}
/*** Function prototypes for pcx ***/

extern const gp_loader gp_pcx;

int gp_match_pcx(const void *buf);

int gp_read_pcx_ex(gp_io *io, gp_pixmap **img, gp_storage *storage,
                   gp_progress_cb *callback);

static inline gp_pixmap *gp_load_pcx(const char *src_path,
                                     gp_progress_cb *callback)
{
        return gp_loader_load_image(&gp_pcx, src_path, callback);
}

static inline gp_pixmap *gp_read_pcx(gp_io *io, gp_progress_cb *callback)
{
        return gp_loader_read_image(&gp_pcx, io, callback);
}
/*** Function prototypes for gif ***/

extern const gp_loader gp_gif;

int gp_match_gif(const void *buf);

int gp_read_gif_ex(gp_io *io, gp_pixmap **img, gp_storage *storage,
                   gp_progress_cb *callback);

static inline gp_pixmap *gp_load_gif(const char *src_path,
                                     gp_progress_cb *callback)
{
        return gp_loader_load_image(&gp_gif, src_path, callback);
}

static inline gp_pixmap *gp_read_gif(gp_io *io, gp_progress_cb *callback)
{
        return gp_loader_read_image(&gp_gif, io, callback);
}
/*** Function prototypes for psp ***/

extern const gp_loader gp_psp;

int gp_match_psp(const void *buf);

int gp_read_psp_ex(gp_io *io, gp_pixmap **img, gp_storage *storage,
                   gp_progress_cb *callback);

static inline gp_pixmap *gp_load_psp(const char *src_path,
                                     gp_progress_cb *callback)
{
        return gp_loader_load_image(&gp_psp, src_path, callback);
}

static inline gp_pixmap *gp_read_psp(gp_io *io, gp_progress_cb *callback)
{
        return gp_loader_read_image(&gp_psp, io, callback);
}
/*** Function prototypes for psd ***/

extern const gp_loader gp_psd;

int gp_match_psd(const void *buf);

int gp_read_psd_ex(gp_io *io, gp_pixmap **img, gp_storage *storage,
                   gp_progress_cb *callback);

static inline gp_pixmap *gp_load_psd(const char *src_path,
                                     gp_progress_cb *callback)
{
        return gp_loader_load_image(&gp_psd, src_path, callback);
}

static inline gp_pixmap *gp_read_psd(gp_io *io, gp_progress_cb *callback)
{
        return gp_loader_read_image(&gp_psd, io, callback);
}
#endif /* GP_LOADERS_GEN_H */
